;;;--------------------------------------------------------------------;;;
;;;                                     ;;;
;;;                    ArcTxt.LSP Version 3.1                          ;;;
;;;                 AutoCAD r13-15 for Windows                      ;;;
;;;                           13.10.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;                    E-Mail: tb5@ugm.zsmk.ru                         ;;;
;;;--------------------------------------------------------------------;;;

;;
;;        , 
;;          , 
;;       ,   
;;                ArcTxt
;;


    ;
    ;   3.1   .
    ;       AutoCAD.
    ;    AutoCAD 2000 (15)  ,  
    ;      
    ; CELWEIGHT,     .    
    ;  AutoCAD   ,  
    ;    CELWEIGHT  , . .
    ;        
    ;    AutoCAD    2000 (15)
    ; 
    ;   3.1     AutoCAD 2000
    ;        .
    ; 
    
    

	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     
	
	;  ,      
	; Scale to Paper Space ,   
	;       
	; .      
	;    ,    , 
	;    ,    
	; 

(setq ArcTxt t)

;=============================================================
;;;  
;;   ($cmsf)****
(defun $cmsf (/ ent elist mvscale)
    (if	(= 0 (getvar "tilemode"))
        (progn
	        (if (setq ss1
	                (ssget "X" (list '(0 . "VIEWPORT") (cons 69 (getvar "cvport"))))
	            ) ;_ end of setq
	            (setq ent (ssname ss1 0))
	        ) ;_end of if
	        (setq mvscale ($msf ent)
	              my mvscale)
        )	;_end of progn tilemode /= 1
        (if (= 0 (getvar "dimscale"))
            (setq my nil)
            (setq my (getvar "dimscale"))
        )
    )	;_ end if tilemode = 0
) ;_ end of defun

(defun $msf (ent / vpxdata ms_height ps_height $msf entxdata)
    (defun entxdata (ent appid / d)
        (if (and (setq d (entget ent (list appid)))
	             (setq d (assoc -3 d))
	             (cdadr d)
	        ) ;_ end of and
	         (cdadr d)
        ) ;_ end of if
    ) ;_ end of defun
    (setq vpxdata   (entxdata ent "acad")
	      ms_height (cdr (nth 6 vpxdata))
	      ps_height (cdr (assoc 41 (entget ent)))
    ) ;_ end of setq
    (/ ms_height ps_height)
  ) ;_ end of defun $msf

;;****

;    
(defun get_Scale ( / ret_Sc)
    ($cmsf) 
    (setq ret_Sc my) 
    t ret_Sc
)

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;    
(defun SetOpt ()
; 
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

(defun $RetOpt ()
; 
	(if sblip (setvar "BLIPMODE" sblip))
	(if scmde (setvar "CMDECHO" scmde))
)

(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	    ;  
	(setq oldLType (getvar "CELTYPE"))	    ;   
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setq oldWeight (getvar "CELWEIGHT"))	;  
	)
)

(defun $RetLProp ()
;   
	(if oldColor (setvar "CECOLOR" oldColor))
	(if oldLType (setvar "CELTYPE" oldLType))
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
		(if oldWeight (setvar "CELWEIGHT" oldWeight))
	)
)

;  OSNAP
(defun $Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun $Osnap_On  ()
	(if sosnapm (setvar "OSMODE" sosnapm))
)

;-------------------------------------------------------------

;     
(defun dtr (Ang)
	(/ (* Ang pi) 180)
)

;     
(defun rtd (Ang) 
	 (* Ang (/  180 pi))
)

;    
(defun arcsin ( x / )
    (atan 
        (/  x  (sqrt (- 1.0 (* x x))) )
    )
) ; defun arcsin

;  
(defun tan (Ang)
	(setq tangens (/ (sin Ang) (cos Ang)))
	T tangens
)

;-------------------------------------------------------------

;  
(defun getSymL (Sym th / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8) )
        (progn
            (setq cth th)
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;        
(defun getAngXo ( R Xo / Ang)
    (setq Ang (* 2.0 (arcsin (/ (/ Xo 2.0) R))))
    t Ang
)

;   ,   
(defun drwArcTxt (Txt sp cp up th scale mode 
                   / sAng uAng R TL K1 K2 A cSum lcSym cAng csAng csp
                     ArCOL ArWD count ss ArcTxtDat dy)
    ; mode -  .  mode=1 -   ,
    ;  mode=2 -   
    
    ($SaveLProp) ;    

	(setq ArCOL (getvar "DIMCLRD"))	; , - 
									;  
	(setq ArWD (getvar "DIMLWD"))	;  , - 
									;  
	
	(if (= mode 2)
	    (setq dy (- (+ th (* scale 1))))
	    (setq dy (* scale 1))
	)
	(setq sAng (angle cp sp))
	(setq uAng (angle cp up))
	(setq R (distance cp sp))
	(setq TL (strlen Txt))
	
	(if (>= (sin sAng) 0.0)
	    (if (and (> uAng sAng) (< uAng (+ sAng (dtr 180))) )
	        (setq K1 1      K2 (- 1)  A (+ TL 1) )
	        (setq K1 (- 1)  K2 (- 1)  A 0 )
	    )
	    (if (and (< uAng sAng) (> uAng (- sAng (dtr 180))) )
	        (setq K1 (- 1)  K2 1  A (+ TL 1) )
	        (setq K1 1      K2 1  A 0 )
	    )
	)
	
	(setq cSym (substr Txt (abs (- A 1)) 1))

	(setq lcSym (getSymL cSym th))
	
	(if (= A 0)
	    (setq cAng sAng)
	    (setq cAng (+ sAng (* K1 (getAngXo R lcSym))))
	)

	(setq count 1)
	(setq ss nil)
	(setq ss (ssadd))

	(setvar "CECOLOR" (rtos ArCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
	
	(while (<= count TL)
        (if (> A 0)
            (progn
                (if (> (abs (- A count)) 0)
	                (setq cSym (substr Txt (abs (- A count)) 1) )
	            )

                (setq lcSym (getSymL csym th))
                (setq cAng (+ cAng (* K1 (getAngXo R lcSym))))
            )
            (progn

                (setq lcSym (getSymL csym th))
                (if (> (abs (- A count)) 0)
	                (setq cSym (substr Txt (abs (- A count)) 1) )
	            )
                (setq cAng (+ cAng (* K1 (getAngXo R lcSym))))
            )
        )
	    (setq csAng (+ cAng (* K2 (dtr 90))))
	    (setq csp (polar cp cAng (- R (* dy K2))) )
	    ($Osnap_Off)
	    (command "_text" csp th (rtd csAng) cSym )
	    ($Osnap_On)
	    (ssadd (entlast) ss)
	    
	    (setq count (+ count 1))
    )

    (setq ArcTxtDat (list cAng ss) )
    
    ($RetLProp) ;        
    t  ArcTxtDat
)
 
;;;   
;=============================================================



;;;  
;=============================================================

;      
(defun C:ArcTxt ( / Txt1 Txt2 sp cp R up Scale bHtxt TxtObj1 TxtObj2 TxtDat1 TxtDat2
		     ArcName ArcDat ArcType)

    (setq Scale (get_Scale))    
    
    (setq Txt1 (getstring t "\n   : ")) ;     
    (setq Txt2 (getstring t "\n   : ")) ;     
    
    (if (and (null Txt1) (null Txt2))      
        (prompt "\n  .")
        (progn    
            (initget 0 "")
            (setq cp (getpoint "\n  [  ]: "))
            (if (eq cp "")
                (progn
                    (setq ArcName nil)
                    (while (null ArcName)
                        (initget 1)
                        (setq ArcName (car (entsel "\n  : ")))
		                (setq ArcDat (entget ArcName))
                        (setq ArcType (cdr (assoc 0 ArcDat)))
                        (if (or (eq ArcType "ARC") (eq ArcType "CIRCLE") )
                            (progn
                                (setq cp (cdr  (assoc 10 ArcDat)))
                                (setq R (cdr (assoc 40 ArcDat)))
                            )
                            (progn
                                (setq ArcName nil)
                                (princ "\n     .")
                            )
                        )
                    )
                    (setq sp (getpoint cp "\n  : "))
                    (setq sAng (angle cp sp))
                    (setq sp (polar cp sAng R))
                ) ; progn
                (progn
                    (initget 1)
                    (setq sp (getpoint cp "\n  : "))
                )
            )
            (initget 1)
            (grdraw cp sp 1)
            (setq up (getpoint sp "\n : "))
            (setq bHtxt (* 0.875 (getvar "DIMTXT") Scale))  ;  
                                                            ;   * 0.875
            
            (if (not (or (null Txt1) (= Txt1 "") (= Txt1 " ") ))
                (progn
                    (setq TxtDat1 (drwArcTxt Txt1 sp cp up bHtxt scale 1))
                    (setq TxtObj1 (cadr TxtDat1))
                    (UnBlock sp TxtObj1)
                 )
            )
            (if (not (or (null Txt2) (= Txt2 "") (= Txt2 " ") ))
                (progn
                    (setq TxtDat2 (drwArcTxt Txt2 sp cp up bHtxt scale 2))
                    (setq TxtObj2 (cadr TxtDat2))
                    (UnBlock sp TxtObj2)
                )
            )
	        
            (command "_regen")
        )
    )
)

(princ "\n     ArcTxt.lsp  ")