;;;--------------------------------------------------------------------;;;
;;;                                             ;;;
;;;                    Com2002.lsp Version 4.0                         ;;;
;;;                  AutoCAD 2002 for Windows                       ;;;
;;;                           30.04.02                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;                    E-Mail: tb5@ugm.zsmk.ru                         ;;;
;;;--------------------------------------------------------------------;;;

;;
;;         :
;;         , 
;;            
;;                xlineOffset
;;
;;            
;;         
;;                xlineAng
;;
;;          RFill
;;                FilletR
;;
;;          
;;                ChamfLL
;;
;;           
;;                ChamfAng
;;
;;           
;;                DimLineD  DimLineAligD
;;
;;            
;;                DimLine1  DimLineD1 DimLineR1
;;                       DimLineAlig1  DimLineAligD1 DimLineAligR1
;;
;;          
;;                DimAngularL
;;
;;           
;;                DimTxtUnder
;;
;;            
;;         
;;                _dimcenter1
;;
;;             
;;                DimDText
;;
;;              
;;                DimLText
;;
;;              
;;                (SetLType X)
;;                X -   :
;;                     0 - 
;;                     1 - 
;;                     2 - 
;;                     3 - 
;;                     4 - 
;;
;;              
;;                SelLType
;;
;;         
;;                DelLHlp
;;
;;           
;;                LinBreak1
;;
;;           
;;                LinBreak
;;
;;          
;;                LinPerish
;;


    ;
    ;   4     AutoCAD 2002.
    ;
    ;   3.1   .
    ;       AutoCAD.
    ;    AutoCAD 2000 (15)  ,  
    ;      
    ; CELWEIGHT,     .    
    ;  AutoCAD   ,  
    ;    CELWEIGHT  , . .
    ;        
    ;    AutoCAD    2000 (15)
    ; 
    


;=============================================================
;;;  
;;   ($cmsf)****
(defun $cmsf (/ ent elist mvscale)
    (if	(= 0 (getvar "tilemode"))
        (progn
	        (if (setq ss1
	                (ssget "X" (list '(0 . "VIEWPORT") (cons 69 (getvar "cvport"))))
	            ) ;_ end of setq
	            (setq ent (ssname ss1 0))
	        ) ;_end of if
	        (setq mvscale ($msf ent)
	              my mvscale)
        )	;_end of progn tilemode /= 1
        (if (= 0 (getvar "dimscale"))
            (setq my nil)
            (setq my (getvar "dimscale"))
        )
    )	;_ end if tilemode = 0
) ;_ end of defun

(defun $msf (ent / vpxdata ms_height ps_height $msf entxdata)
    (defun entxdata (ent appid / d)
        (if (and (setq d (entget ent (list appid)))
	             (setq d (assoc -3 d))
	             (cdadr d)
	        ) ;_ end of and
	         (cdadr d)
        ) ;_ end of if
    ) ;_ end of defun
    (setq vpxdata   (entxdata ent "acad")
	      ms_height (cdr (nth 6 vpxdata))
	      ps_height (cdr (assoc 41 (entget ent)))
    ) ;_ end of setq
    (/ ms_height ps_height)
  ) ;_ end of defun $msf

;;****

;    
(defun get_Scale ( / ret_Sc)
    ($cmsf) 
    (setq ret_Sc my) 
    t ret_Sc
)

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;  
(defun SetOpt ()
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

;  
(defun $RetOpt ()
	(if sblip (setvar "BLIPMODE" sblip))
	(if scmde (setvar "CMDECHO" scmde))
)

;  OSNAP
(defun $Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun $Osnap_On  ()
	(if sosnapm (setvar "OSMODE" sosnapm))
)

;-------------------------------------------------------------

;     
(defun dtr (Ang)
	(/ (* Ang pi) 180)
)

;     
(defun rtd (Ang) 
	 (* Ang (/  180 pi))
)

;  
(defun tan (Ang)
	(setq tangens (/ (sin Ang) (cos Ang)))
	T tangens
)

;    
(defun arcsin ( x / )
    (atan 
        (/  x  (sqrt (- 1.0 (* x x))) )
    )
) ; defun arsin

;-------------------------------------------------------------
;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;  SelObj
(defun MoveObj (SelObj BasePt)
	(command "_Move" SelObj "" bp pause)
	(setq BasePt (getvar "Lastpoint"))
	(princ (strcat "\n : " BasePt))
	T BasePt
)

;  SelObj
(defun RotateObj (SelObj BasePt)
	(princ "\n : ")
	(command "_Rotate" SelObj "" BasePt pause)
)
(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setq oldWeight (getvar "CELWEIGHT"))	;  
	)
)

(defun $RetLProp ()
;   
	(if oldColor (setvar "CECOLOR" oldColor))
	(if oldLType (setvar "CELTYPE" oldLType))
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
		(if oldWeight (setvar "CELWEIGHT" oldWeight))
	)
)

(defun $setLTypeDim ()
    (setq Scale (get_Scale))
    
	(setq TxtCOL (getvar "DIMCLRD"))	    ; , - 
										    ;  

	(setq TxtH (* (getvar "DIMTXT") Scale))	;  
											;  

	(setq ArWD (getvar "DIMLWD"))	        ;  , - 
									        ;  
	
	(setvar "CECOLOR" (rtos TxtCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
)
;;;   
;=============================================================


;;;  
;=============================================================


;;;   
;=============================================================
;***///\\\***
(defun dimang ( / Obj1 Obj2 Obj1Name Obj1Dat Obj1Type DimEntName DimEntDat sp)
;    
  (setq Obj1 nil)
  (setq Obj2 nil)
  (while (and (null Obj1) (null Obj2))
    (setq Obj1 (entsel "\n , ,   : "))
    (setq Obj1Name (car Obj1))
    (setq Obj1Dat (entget Obj1Name))
    (setq Obj1Type (cdr (assoc 0 Obj1Dat)))
    (cond
        ((= Obj1Type "LINE")
            (progn
                (setq Obj2 nil)
                (while (null Obj2)
                    (setq Obj2 (entsel "\n  : "))
                    (setq Obj2Name (car Obj2))
                    (setq Obj2Dat (entget Obj2Name))
                    (setq Obj2Type (cdr (assoc 0 Obj2Dat)))
                    (if (not (= Obj2Type "LINE"))
                        (progn
                            (setq Obj2 nil)
                            (princ "\n   .")
                        )
                    )
                )
                (princ)
                ;(setq Obj1 Obj1Name )
                ;(setq Obj2 Obj2Name )
                (command "_dimangular" Obj1 Obj2 pause)
                (setq DimEntName (entlast))
                (setq DimEntDat (entget DimEntName))
            )
        )
        ((= Obj1Type "CIRCLE")
            (progn
                (setq Obj2 Obj1)
                (princ)
                (command "_dimangular" Obj1 pause pause)
            )
        )
        ((= Obj1Type "ARC")
            (progn
                (setq Obj2 Obj1)
                (princ)
                (command "_dimangular" Obj1 pause)
                (setq DimEntName (entlast))
                (setq DimEntDat (entget DimEntName))
            )
        )
        ((= Obj1Type "LWPOLYLINE")
            (progn
                (setq Obj2 Obj1)
                (princ)
                (command "_dimangular" Obj1 pause pause)
                (setq DimEntName (entlast))
                (setq DimEntDat (entget DimEntName))
            )
        )
        ((and (/= Obj1Type "ARC") (/= Obj1Type "LWPOLYLINE") (/= Obj1Type "CIRCLE") (/= Obj1Type "LINE"))
            (progn
                (setq Obj1 nil Obj2 nil)
                (princ "\n   ,     .")
            )
        )
    )
  )
    
    
    ;(command "_dimangular" Obj1)

    (setq DimEntName (entlast))
    (setq DimEntDat (entget DimEntName))
    t DimEntDat
)

;    
(defun C:DimAngularL ( / cp sp ep up AngArc RArc DimTxt DimEntName DimEntDat 
                         LArc uRArc uAngArc uLarc uDimTXT Xo uXo )
     
     ;(princ "\n : ")
     ;(command "_dimangular" Pause Pause)
     (setq DimEntDat (dimang))
     ;(setq DimEntName (entlast))
     ;(setq DimEntDat (entget DimEntName))
     ;(setq DimEntDat (dimang))
     (setq cp (cdr (assoc 15 DimEntDat)))     ;  
     (setq sp (cdr (assoc 13 DimEntDat)))     ;   
     (setq ep (cdr (assoc 14 DimEntDat)))     ;   
     (setq up (cdr (assoc 10 DimEntDat)))     ;    
     (setq AngArc (cdr (assoc 42 DimEntDat))) ;  
     (setq RArc (distance ep cp))             ;  
     (setq DimTxt (cdr (assoc 1 DimEntDat)))  ;  
     
     (setq LArc (* RArc AngArc))

     (setq uRArc nil)
     (initget (+ 2 4))
     (setq uRArc (getreal (strcat "\n  <" (rtos RArc 2 4) ">: ")))
     (if (null uRArc) 
         (setq uRArc RArc)
         (setq RArc uRArc)
     )
     
     (setq uAngArc nil)
     (initget  (+ 2 4) "X")
     (setq uAngArc (getreal (strcat "\n  [X] <" (rtos (rtd AngArc) 2 4) "> ")))
     (if (null uAngArc)
         (setq uAngArc AngArc)
         (if (= uAngArc "X")
             (progn
                 (if (<= AngArc Pi)
                     (setq Xo (* 2.0 uRArc (sin (/ AngArc 2.0))))
                     (setq Xo (* 2.0 uRArc (sin (/ (- (* 2.0 pi) AngArc) 2.0))))
                 )
                 
                 (initget (+ 2 4))
                 (setq uXo (getreal (strcat "\nX  <" (rtos Xo 2 4) ">: ")))
                 (if (null uXo) 
                     (setq uXo Xo)
                     (setq Xo uXo)
                 )
                 (if (<= AngArc pi)
                     (setq uAngArc (rtd (* 2.0 (arcsin (/ (/ uXo 2.0 uRArc))))))
                     (setq uAngArc (- 360.0 (rtd (* 2.0 (arcsin (/ (/ uXo 2.0) uRArc))))))
                 )
                 (setq uAngArc (dtr uAngArc))
             )
             (setq uAngArc (dtr uAngArc))
         )
     )
     (setq AngArc uAngArc)
     (setq uLArc nil)
     (initget (+ 2 4))
     (setq uLArc (getreal (strcat "\n  <" (rtos (* uRArc uAngArc) 2 4) ">: ")))
     (if (null uLArc) 
         (setq uLArc (* uRArc uAngArc))
         ;;;(setq uLArc (* uRArc AngArc))
     )
     
     (setq uDimTXT (strcat "L=" (rtos (round uLArc 1) 2 1) " no R=" (rtos (round uRArc 1) 2 1)))     
	
	 (setq DimEntDat (subst (cons 1 uDimTXT) (assoc 1 DimEntDat) DimEntDat ))
	 (entmod DimEntDat)
)




;     ""
(defun $DimPerfT ( LEnt Perf)
	(setq Txt (cdr (assoc 1 LEnt)))
	(if (= Txt "") (setq Txt "<>"))
	(setq Txt (strcat Perf Txt))
	(setq LEnt (subst (cons 1 Txt) (assoc 1 LEnt) LEnt ))
	(entmod LEnt)
)

;    
(defun $DimSuffUnder ( LEnt Suff)
	(setq Txt (cdr (assoc 1 LEnt)))
	(if (= Txt "") (setq Txt "<>"))
	(setq Txt (strcat Txt "\\X " Suff))
	(setq LEnt (subst (cons 1 Txt) (assoc 1 LEnt) LEnt ))
	(entmod LEnt)
)

;  
(defun $DimLine (dCom DimPtList / oldDimAso)
    (setq oldDimAso (getvar "DIMASO"))
    (setvar "DIMASO" 1)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        (setvar "DIMASO" oldDimAso)
        (GC)
    )
    (if (null DimPtList)
        (command dCom Pause Pause Pause)
        (command dCom (car DimPtList) (cadr DimPtList) Pause)
    )
    (setvar "DIMASO" oldDimAso)
)

;  
;   
(defun $DimLine1 (dCom DimPtList)
    (setq oldDimAso (getvar "DIMASO"))
    (setvar "DIMASO" 1)
    (setq OldDIMSD1 (getvar "DIMSD1"))
    (setq OldDIMSE1 (getvar "DIMSE1"))
    (setvar "DIMSD1" 1)
    (setvar "DIMSE1" 1)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        (setvar "DIMSD1" OldDIMSD1)
        (setvar "DIMSE1" OldDIMSE1)
        (setvar "DIMASO" oldDimAso)
        (GC)
    )
    (if (null DimPtList)
        (command dCom Pause Pause Pause)
        (command dCom (car DimPtList) (cadr DimPtList) Pause)
    )
    (setvar "DIMSD1" OldDIMSD1)
    (setvar "DIMSE1" OldDIMSE1)
    (setvar "DIMASO" oldDimAso)
)

;    
;  
(defun c:DimAlign0 ( / pt1 pt2 oldDIMSE1 oldDIMSE2)
    (setq p1 (getpoint "\n  : ")) 
    (setq p2 (getpoint "\n  : ")) 
    (setq oldDIMSE1 (getvar "DIMSE1"))
    (setq oldDIMSE2 (getvar "DIMSE2"))
    (setvar "DIMSE1" 1)
    (setvar "DIMSE2" 1)
    (command "_dimaligned" p1 p2 p2)
    (setvar "DIMSE1" oldDIMSE1)
    (setvar "DIMSE2" oldDIMSE2)
)


;   
;  
(defun C:DimTxtUnder ( / Txt Obj1 Obj1Name Obj1Dat Obj1Type)
    (setq Txt (getstring t "\n  : "))
    (if (not (= Txt ""))
        (progn
		    (setq Obj1Dat nil)
		    (while (null Obj1Dat)
		        (setq Obj1 (entsel "\n : "))
		        (setq Obj1Name (car Obj1))
		        (setq Obj1Dat (entget Obj1Name))
		        (setq Obj1Type (cdr (assoc 0 Obj1Dat)))
		    
		        (if (= Obj1Type "DIMENSION")
		    	    ($DimSuffUnder Obj1Dat Txt)
		    	    (progn
		    	        (princ "\n    .")
        		        (setq Obj1Dat nil)		    	    
        		    )
		        )
		    )
		)
    )
)

;     
;    
(defun C:DimLineD ()
    ($DimLine "_dimlinear" nil)
    ($DimPerfT (entget (entlast)) "%%c")
)

;   
;  
(defun C:DimLineAligD ()
    ($DimLine "_dimaligned" nil)
    ($DimPerfT (entget (entlast)) "%%c")
)

;     
;    
(defun C:DimLine1 ( / pt1 pt2)
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimlinear" (list pt1 pt2))
)


;     
;    
;   
(defun C:DimLineD1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimlinear" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "%%c")
)

;     
;    
;   
(defun C:DimLineR1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimlinear" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "R ")
)

;     
;   
(defun C:DimLineAlig1 ( / pt1 pt2)
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimaligned" (list pt1 pt2))
)

;     
;   
;   
(defun C:DimLineAligD1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimaligned" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "%%c")
)

;     
;    
;   
(defun C:DimLineAligR1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimaligned" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "R ")
)

(defun C:dimcenter1 ( / SS)
;      
;   
    (setq SS (ENTSEL "\n   : "))
    (if (not (null SS))
        (progn
            ($SaveLProp)
            ($SetLType 3)
            (command "_dimcenter" SS)
            ($RetLProp)
        )
    )
)


;;      
(defun C:DimDText ( / TxtCOL TxtH ArWD scale CurTxtStyle th pTxt)
	(SetOpt)
	($SaveLProp)
    (setq Scale (get_Scale))
    
    ($setLTypeDim)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        ($RetOpt)
        ($RetLProp)
        (GC)
    )

	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
    (terpri)
    (princ)
    (princ)
    
    (setq pTxt (getpoint "\n : "))
  
	(if (= th 0.0)
        (command "_dtext" pTxt TxtH )
        (command "_dtext" pTxt )
    )
	($RetOpt)
	($RetLProp)
)

;;       
(defun C:DimLText ( / TxtCOL TxtH ArWD scale CurTxtStyle th pTxt Txt LEnt)
	(SetOpt)

	($SaveLProp)
    (setq Scale (get_Scale))
    
    ($setLTypeDim)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        ($RetOpt)
        ($RetLProp)
        (GC)
    )

	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
    (terpri)
    (princ)
    (princ)
    ($RetOpt)
    (setq pTxt (getpoint "\n : "))
    (setq Txt (getstring t "\n  : "))
    (setq Txt (strcat "%%u" Txt))
	(if (= th 0.0)
        (command "_text" pTxt TxtH 0.0 Txt)
        (command "_text" pTxt 0.0 Txt)
    )
	
	(SetOpt)
	($RetLProp)
	
	($RetOpt)
)

;  , 
;     
(defun C:xlineOffset()
	(setq OfsetD (getvar "OFFSETDIST"))
	(setq OfsetDT (rtos OfsetD))
	(setq OfsetD nil)
	(initget (+ 2 4 ))
	(setq OfsetD (getreal (strcat "\n   <" OfsetDT ">: ")))
	(if (null OfsetD)
		(setq OfsetD (getvar "OFFSETDIST"))
		(setvar "OFFSETDIST" OfsetD)
	)
	(command "_xline" "_Offset" OfsetD pause pause)
	
)


;     
;  
(defun C:xlineAng()
	(setq Ang nil)
	(initget (+ 2 4 ))
	(setq Ang (getangle "\n   <0>: "))
	(if (null Ang)
		(setq Ang 0.0)
		(setq Ang (rtd Ang))
	)
	(command "_xline" "_Ang" Ang pause)
	
)

;   RFill
(defun C:FilletR()
	(setq RFillT (rtos (getvar "FILLETRAD")))
	(setq RFill (getreal (strcat "\n  <" RFillT ">: ")))
	(if (null RFill) 
		(setq RFill "FILLETRAD")
		(setvar "FILLETRAD" RFill)
	)
	(command "_fillet" )
)


;;
;   
(defun C:ChamfLL()
	(setq D1T (rtos (getvar "chamferA")))
	(setq D2T (rtos (getvar "chamferB")))
	(setq D1 (getdist (strcat "\n     <" D1T ">: ")))
	(if (null D1)
		(setq D1 (getvar "chamferA"))
		(setvar "chamferA" D1)
	)
	(setq D2 (getvar "chamferB"))
	(setq D2T (rtos (getvar "chamferB")))
	(setq D2 (getdist (strcat "\n     <" D2T ">: ")))
	(if (null D2) 
		(setq D2 (getvar "chamferB")) 
		(setvar "chamferB" D2)
	)

	(command "_chamfer" "_D" D1 D2)
	
	(command "_chamfer")
	(prin1)
)

;    
(defun C:ChamfAng()
	(setq D1 (getvar "chamferC"))
	(setq D1T (rtos D1))
	(setq D1 (getdist (strcat "\n     <" D1T ">: ")))
	(if (null D1) 
		(setq D1 (getvar "chamferC"))
		(setvar "chamferC" D1)
	)
	
	(setq Ang1 (getvar "chamferD"))
	(setq Ang1T (rtos (rtd Ang1)))
	(setq Ang1 (getangle (strcat "\n    <" Ang1T ">: ")))
	(if (null Ang1)
		(setq Ang1 (rtd (getvar "chamferD")))
		(progn
			(setq Ang1 (rtd Ang1))
			(setvar "chamferD" Ang1)
		)
	)
	
	(command "_chamfer" "_A" D1 Ang1)
	
	(command "_chamfer")
	(prin1)
)

;=============================================================;
;    



;=============================================================;
(princ "\n     Com2002.lsp  ")
(princ "\n***                   ACAD TOOLS.  COMMANDS                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.ru               ***")
