;;;--------------------------------------------------------------------;;;
;;;                          ;;;
;;;                   PosMark.LSP Version 3.1                          ;;;
;;;                AutoCAD r13-15 for Windows                       ;;;
;;;                           10.10.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;                    E-Mail: tb5@ugm.zsmk.ru                         ;;;
;;;--------------------------------------------------------------------;;;


;;
;;     :
;;     1.      ( C:PosMark)


    ;
    ;   3.1   .
    ;       AutoCAD.
    ;    AutoCAD 2000 (15)  ,  
    ;      
    ; CELWEIGHT,     .    
    ;  AutoCAD   ,  
    ;    CELWEIGHT  , . .
    ;        
    ;    AutoCAD    2000 (15)
    ; 
    

	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
	; !!!
	;       
	;       0.0,   
	;       1.2    
	;   (   ),  
	;         
	;      
	
	;  ,      
	; Scale to Paper Space ,   
	;       
	; .      
	;    ,    , 
	;    ,    
	; 

(setq PosMark t)

;=============================================================
;;;  
;;   ($cmsf)****
(defun $cmsf (/ ent elist mvscale)
    (if	(= 0 (getvar "tilemode"))
        (progn
	        (if (setq ss1
	                (ssget "X" (list '(0 . "VIEWPORT") (cons 69 (getvar "cvport"))))
	            ) ;_ end of setq
	            (setq ent (ssname ss1 0))
	        ) ;_end of if
	        (setq mvscale ($msf ent)
	              my mvscale)
        )	;_end of progn tilemode /= 1
        (if (= 0 (getvar "dimscale"))
            (setq my nil)
            (setq my (getvar "dimscale"))
        )
    )	;_ end if tilemode = 0
) ;_ end of defun

(defun $msf (ent / vpxdata ms_height ps_height $msf entxdata)
    (defun entxdata (ent appid / d)
        (if (and (setq d (entget ent (list appid)))
	             (setq d (assoc -3 d))
	             (cdadr d)
	        ) ;_ end of and
	         (cdadr d)
        ) ;_ end of if
    ) ;_ end of defun
    (setq vpxdata   (entxdata ent "acad")
	      ms_height (cdr (nth 6 vpxdata))
	      ps_height (cdr (assoc 41 (entget ent)))
    ) ;_ end of setq
    (/ ms_height ps_height)
  ) ;_ end of defun $msf

;;****

;    
(defun get_Scale ( / ret_Sc)
    ($cmsf) 
    (setq ret_Sc my) 
    t ret_Sc
)

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;  OSNAP
(defun $Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun $Osnap_On  ()
	(if sosnapm (setvar "OSMODE" sosnapm))
)

(defun SetOpt ()
; 
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

(defun $RetOpt ()
; 
	(if sblip (setvar "BLIPMODE" sblip))
	(if scmde (setvar "CMDECHO" scmde))
)

(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setq oldWeight (getvar "CELWEIGHT"))	;  
	)
)

(defun $RetLProp ()

;   
	(if oldColor (setvar "CECOLOR" oldColor))
	(if oldLType (setvar "CELTYPE" oldLType))
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
		(if oldWeight (setvar "CELWEIGHT" oldWeight))
	)
)

;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;;;   
;=============================================================



(defun c:PosMark (/ p1 p2 p3 x y x2 y2 i ch ch ss
                    PosCOL PosWD Scale
                    TxtH CurTxtStyle th Jut dxTxtPt TxtLen)

	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     

    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        ;   
        ($RetOpt)
        ($Osnap_On)
        ($RetLProp)
        (GC)
        (setvar "FILEDIA" 1)
        (if msg (princ "\n Rough.shx    " ))
    )


    (setq Scale (get_Scale))

	(setq PosCOL (getvar "DIMCLRD"))	; , - 
									    ;  
	(setq PosWD (getvar "DIMLWD"))	    ; , - 
									    ;  

	(setq TxtH (* 1.2 Scale (getvar "DIMTXT")))	;  
											    ;   * 1.2

	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle)))) ;   
	                                                              
	
	;  
	($SaveLProp)	
	(setvar "CECOLOR" (rtos PosCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" PosWD)
	)
    ($Osnap_Off)
    (SetOpt)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        ;   
        ($RetOpt)
        ($Osnap_On)
        ($RetLProp)
        (GC)
        (setvar "FILEDIA" 1)
        (if msg (princ "\n   " ))
    )
  (setq p2 t)
  (while p2
    (setq p2 (getpoint "\n   : "))
    (if (not (null p2))
    (progn
    	(setq p1 (getpoint p2 "\n   : ")
	  		x  (car p1)
	  		y  (cadr p1)
	  		x2 (car p2)
	  		y2 (cadr p2)
	  		i  0
    	)

		(if (> x x2)
			(progn
				(setq Jut nil)
				(setq dxTxtPt 1.0)	
			)
			(progn
				(setq Jut "_R")
				(setq dxTxtPt (- 2.0))
			)
		)

    ;(setq ch (getint "\n  : "))
    	(setq ch (getstring "\n  : "))
		(if (= ch "") (setq ch nil))
	
		(if (not (null ch))   ;    
	    	(progn
	    		(setq TxtLen (+ (getSymL ch (/ TxtH scale) scale) 2.0) )
	        	(setq ss nil)
            	(setq ss (ssadd))
	    		(command "_LINE" p1 p2 "")
    			(ssadd (entlast) ss)
    			(command "_DONUT" 0 (* 0.5 Scale) p2 "")
    			(ssadd (entlast) ss)
    			(UnBlock p2 ss)
    			(setq ss nil)
    		)
    	)
    	(setq p3 p1)
    	(while ch
      	;(setq ch1 (itoa ch))
      		(setq ch1 ch)

      		(if (<= x x2)
	    	(progn
	       		(command
	          		"_LINE"
	          		p3
	          		(list (- x TxtLen) (cadr p3))
	          		""
	       		)
	       		(if (= th 0.0)
	          		(if (null Jut)
	          			(command
                    		"_TEXT"
	             			(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	             			TxtH
	             			0.0
	             			ch1
	          			)
	          			(command
	            	 		"_TEXT"
	             			"_j"
	             			Jut
	             			(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	             			TxtH
	             			0.0
	             			ch1
	          			)
	          		)
	          		(if (null Jut)
               			(command
	             			"_TEXT"
	             			(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	             			0.0
	             			ch1
	           			)
               			(command
	             			"_TEXT"
	             			"_j"
	             			Jut
	             			(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	            	 			0.0
	        	     			ch1
	       	    			)
	          			)
	       			)
	    		)
	    		(progn
		   			(command
	  		   			"_LINE"
	  		   			p3
	  		   			(list (+ x TxtLen) (cadr p3))
	  		   			""
	  	   			)
	  	   			(if (= th 0.0)
	  		   			(if (null Jut)
	  		     			(command 
	  	 		   				"_TEXT"
	  			   				(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   				TxtH
	  			   				0.0
	  			   				ch1
	  		     				)
	  		     			(command 
	  	 		   				"_TEXT"
	  			   				"_j"
	  			   				Jut
	  			   				(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   				TxtH
	  			   				0.0
	  			   				ch1
	  		     			)
	  		   			)
	  		   			(if (null Jut)
	  		     			(command 
	  	 		   				"_TEXT"
	  			   				(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   				0.0
	  			   				ch1
	  		     			)
	  		     			(command 
	  	 		   				"_TEXT"
	  			   				"_j"
	  			   				Jut
	  			   				(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   				0.0
	  			   				ch1
	  		     			)
	  		   			)
	  	   			)
	   			)
      		) ;_end if

      		(if (/= i 0)
	     		(command "_LINE" (list x (+ (cadr p3) (* 8 Scale))) p3 "")
      		)					;if;_ end if
      		(setq p3 (list x (- (cadr p3) (* 8 Scale)))
	    		i  (1+ i)
      		)
      		(setq ch (getstring "\n  : "))
      		(if (= ch "") (setq ch nil))
      			(if (not (null ch))   ;    
          			(setq TxtLen (+ (getSymL ch (/ TxtH scale) scale) 2.0) )
      			)
	
    		)
    		;(setq p2 nil)
    	)	
    ) ;_end while ch
    

  ) ;_end while p2
  ($RetOpt)
  ($Osnap_On)
  ($RetLProp)
  (command "_REDRAW")
  (if old_error (setq *error* old_error))			; Rest ore old *error* handler
) ;_end



;======================================
(princ "\n     PosMark.lsp  ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.ru               ***")
