;;;--------------------------------------------------------------------;;;
;;;               .               ;;;
;;;                     Proc.lsp Version 3.1                           ;;;
;;;                 AutoCAD r13-15 for Windows                      ;;;
;;;                           10.10.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;                    E-Mail: tb5@ugm.zsmk.ru                         ;;;
;;;--------------------------------------------------------------------;;;


;;
;;         .  
;;          Utilites
;;


    ;
    ;   3.1   .
    ;       AutoCAD.
    ;    AutoCAD 2000 (15)  ,  
    ;      
    ; CELWEIGHT,     .    
    ;  AutoCAD   ,  
    ;    CELWEIGHT  , . .
    ;        
    ;    AutoCAD    2000 (15)
    ; 
    

	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     
	
	;  ,      
	; Scale to Paper Space ,   
	;       
	; .      
	;    ,    , 
	;    ,    
	; 

(setq Proc t)

;=============================================================
;;;  

;;   ($cmsf)****
(defun $cmsf (/ ent elist mvscale)
    (if	(= 0 (getvar "tilemode"))
        (progn
	        (if (setq ss1
	                (ssget "X" (list '(0 . "VIEWPORT") (cons 69 (getvar "cvport"))))
	            ) ;_ end of setq
	            (setq ent (ssname ss1 0))
	        ) ;_end of if
	        (setq mvscale ($msf ent)
	              my mvscale)
        )	;_end of progn tilemode /= 1
        (if (= 0 (getvar "dimscale"))
            (setq my nil)
            (setq my (getvar "dimscale"))
        )
    )	;_ end if tilemode = 0
) ;_ end of defun

(defun $msf (ent / vpxdata ms_height ps_height $msf entxdata)
    (defun entxdata (ent appid / d)
        (if (and (setq d (entget ent (list appid)))
	             (setq d (assoc -3 d))
	             (cdadr d)
	        ) ;_ end of and
	         (cdadr d)
        ) ;_ end of if
    ) ;_ end of defun
    (setq vpxdata   (entxdata ent "acad")
	      ms_height (cdr (nth 6 vpxdata))
	      ps_height (cdr (assoc 41 (entget ent)))
    ) ;_ end of setq
    (/ ms_height ps_height)
  ) ;_ end of defun $msf

;;****

;    
(defun get_Scale ( / ret_Sc)
    ($cmsf) 
    (setq ret_Sc my) 
    t ret_Sc
)

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setq oldWeight (getvar "CELWEIGHT"))	;  
	)
)

(defun $RetLProp ()
;   
	(if oldColor (setvar "CECOLOR" oldColor))
	(if oldLType (setvar "CELTYPE" oldLType))
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
		(if oldWeight (setvar "CELWEIGHT" oldWeight))
	)
)

(defun $setLTypeDim ()
	(setq TxtCOL (getvar "DIMCLRD"))	    ; , - 
										    ;  

	(setq TxtH (* (getvar "DIMTXT") Scale))	;  
											;  

	(setq ArWD (getvar "DIMLWD"))	        ;  , - 
									        ;  
	
	(setvar "CECOLOR" (rtos TxtCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
)

;;;   
;=============================================================


;;;  
;=============================================================
;    . 
(defun C:Proc ( / scale pt pAng Ang tAng tpt ss th Just K)
    (setq Scale (get_Scale))
    
    (initget 1)
    (setq pt (getpoint "\n   : "))
    (initget 1)
    (setq Ang (getangle pt "\n : "))
    (initget 1)
    (setq pAng (getangle pt "\n,     : "))
    (cond
        ((and (>= (Round Ang 2) 0) (<= (Round Ang 2) (dtr 90)))
            (if (and (<= pAng (+ (dtr 180) Ang)) (>= pAng Ang))
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 0.5 scale)))
                    (setq K 1)
                    (setq tAng Ang)
                )
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 4.5 scale)))
                    (setq K (- 1))
                    (setq tAng Ang)
                )
            )
        )
        ((and (> (Round Ang 2) (dtr 90)) (<= (Round Ang 2) (dtr 180)))
            (if (and (< pAng (+ (dtr 180) Ang)) (> pAng Ang))
                (progn
                    (setq tpt (polar pt (+ (dtr 180) Ang) (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 4.5 scale)))
                    (setq K 1)
                    (setq tAng (- Ang (dtr 180)))
                )
                (progn
                    (setq tpt (polar pt (+ (dtr 180) Ang) (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 0.5 scale)))
                    (setq K (- 1))
                    (setq tAng (- Ang (dtr 180)))
                )
            )
        )
        ((and (> (Round Ang 2) (dtr 180)) (<= (Round Ang 2) (dtr 270)))
            (if (and (< pAng Ang) (> pAng (- Ang (dtr 180))))
                (progn
                    (setq tpt (polar pt (- Ang (dtr 180)) (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 0.5 scale)))
                    (setq K (- 1))
                    (setq tAng (- Ang (dtr 180)))
                )
                (progn
                    (setq tpt (polar pt (- Ang (dtr 180)) (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 4.5 scale)))
                    (setq K 1)
                    (setq tAng (- Ang (dtr 180)))
                )
            )
        )
        ((and (> (Round Ang 2) (dtr 270)) (< (Round Ang 2) (dtr 360)))
            (if (and (< pAng Ang) (> pAng (- Ang (dtr 180))))
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 4.5 scale)))
                    (setq K (- 1))
                    (setq tAng Ang)
                )
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 0.5 scale)))
                    (setq K 1)
                    (setq tAng Ang)
                )
            )
        )
    )
    
    ($SaveLProp)
    ($setLTypeDim)

    
    (setq ss (ssadd))   
    ($Osnap_Off)
    (command "_pline" 
        pt
        (polar pt (+ Ang (* K (dtr 60))) (* 4 scale))
        (polar pt (+ Ang (* K (dtr 120))) (* 4 scale))
        "_c"
    )
    (ssadd (entlast) ss)
    (setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
    (if (= th 0.0)
		(command "_text" tpt (* 4 scale) (rtd tAng) "3")
		(command "_text" tpt (rtd tAng) "3")
	)
	(ssadd (entlast) ss)
    (UnBlock pt SS)
    ($Osnap_On)
    ($RetLProp)

    
    
)

;    . 
;(defun $Proc ( pt Ang)
;
;)

;=====================================
(princ "\n     Proc.lsp  ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.ru               ***")
