;;;--------------------------------------------------------------------;;;
;;;                                            ;;;
;;;                     Ring.LSP Version 1.1                           ;;;
;;;               AutoCAD 2000 (15) for Windows                     ;;;
;;;                           29.09.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;                    E-Mail: tb5@ugm.zsmk.ru                         ;;;
;;;--------------------------------------------------------------------;;;


;;
;;          
;;    :
;;    -  Ring
;;

;;
;;   !!!
;;          
;;    Com2000.lsp.    ,   
;;    Com2000.lsp      AutoCAD
;;      UTILITES   Com2000.mnu 
;;    Com2000.lsp     
;;    Com2000.mnl.
;;


;=============================================================
;;   ($cmsf)****
(defun $cmsf (/ ent elist mvscale)
    (if	(= 0 (getvar "tilemode"))
        (progn
	        (if (setq ss1
	                (ssget "X" (list '(0 . "VIEWPORT") (cons 69 (getvar "cvport"))))
	            ) ;_ end of setq
	            (setq ent (ssname ss1 0))
	        ) ;_end of if
	        (setq mvscale ($msf ent)
	              my mvscale)
        )	;_end of progn tilemode /= 1
        (if (= 0 (getvar "dimscale"))
            (setq my nil)
            (setq my (getvar "dimscale"))
        )
    )	;_ end if tilemode = 0
) ;_ end of defun

(defun $msf (ent / vpxdata ms_height ps_height $msf entxdata)
    (defun entxdata (ent appid / d)
        (if (and (setq d (entget ent (list appid)))
	             (setq d (assoc -3 d))
	             (cdadr d)
	        ) ;_ end of and
	         (cdadr d)
        ) ;_ end of if
    ) ;_ end of defun
    (setq vpxdata   (entxdata ent "acad")
	      ms_height (cdr (nth 6 vpxdata))
	      ps_height (cdr (assoc 41 (entget ent)))
    ) ;_ end of setq
    (/ ms_height ps_height)
  ) ;_ end of defun $msf

;;****

;    
(defun get_Scale ( / ret_Sc)
    ($cmsf) 
    (setq ret_Sc my) 
    t ret_Sc
)

;  
;   : Ring
(defun $Ring ( );/ scmde       InpMode 
				 ;RRingnar    RRingvn
				 ;bp          SelObj
				 ;R1          R2
				 ;BlkName     S1)
				 
	(setq scmde (getvar "CMDECHO"))
	(initget 1 "Diameter")
	(setq RRingnar (getdist "\n   [Diameter]: "))
	(if (/= RRingnar "Diameter") (setq InpMode 1))
	(if (= RRingnar "Diameter")
		(progn
			(setq InpMode 2)
			(initget 1)
			(setq RRingnar (getdist "\n  : "))
			(setq RRingnar (/ RRingnar 2))
		)

	)
	(if (= InpMode 1)
		(progn
			(initget 1 "Diameter")		
			(setq RRingvn (getdist "\n   [Diameter]: "))
			(if (= RRingvn "Diameter")
				(progn
					(initget 1)
					(setq RRingvn (getdist "\n  : "))
					(setq RRingvn (/ RRingvn 2))
				)
			)
		)
	)
	(if (= InpMode 2)
		(progn
			(initget 1 "Radius")		
			(setq RRingvn (getdist "\n   [Radius]: "))
			(if (= RRingvn "Radius")
				(progn
					(initget 1)
					(setq RRingvn (getdist "\n  : "))
					(setq RRingvn (* RRingvn 2))
				)
			)
			(setq RRingvn (/ RRingvn 2))
		)
 	)

	(setq bp (list 100000.0 100000.0 0.0))
	(setq SelObj (DrwRing bp RRingvn RRingnar))
	
	(if (> RRingnar RRingvn)
		(progn
			(setq R1 RRingnar)
			(setq R2 RRingvn)
		)
		(progn
			(setq R1 RRingvn)
			(setq R2 RRingnar)
		)
	)
	(setq BlkName (strcat "Dt_D" (rtos R1 2 0) "d" (rtos R2 2 0)))
	
	(if (null (tblsearch "BLOCK" BlkName))
		(command "-block" BlkName bp SelObj "")
		(command "-block" BlkName "_Y" bp SelObj "")
	)
	(prin1)
	(command "-insert" BlkName pause "" "" "")
    (prin1)
    (setq S1 nil)
	(setvar "CMDECHO" scmde)
	(prin1)
)

(defun DrwRing (cp RRingvn RRingnar / S1)
 	(setq S1 nil)
 	(setq S1 (ssadd))
 	(command "_CIRCLE" cp RRingvn)
 	(ssadd (entlast) S1)
 	(command "_CIRCLE" cp RRingnar)
 	(ssadd (entlast) S1)
 	T S1
	
)

(defun C:Ring ()
	($Ring)
	(princ)
)

;=============================================================
(princ "\n     Ring  ")
