;;;--------------------------------------------------------------------;;;
;;;                                 ;;;
;;;                    Sector.lsp Version 1.1                          ;;;
;;;                 AutoCAD r13-15 for Windows                      ;;;
;;;                           19.10.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;                    E-Mail: tb5@ugm.zsmk.ru                         ;;;
;;;--------------------------------------------------------------------;;;


;;
;;          
;;   :
;;       :
;;           (  )     -  SectorA
;;           (  )  
;;             (  )      -  SectorX
;;           (  )  
;;              (  ) -  SectorL
;;

;;
;;     3.1     AutoCAD 2000
;;          .
;;           
;;   (  )
;;


;;
;;   !!!
;;          
;;    Com2000.lsp.    ,   
;;    Com2000.lsp      AutoCAD
;;      UTILITES   Com2000.mnu 
;;    Com2000.lsp     
;;    Com2000.mnl.
;;



;; 
;  
(defun getSectRad ( / flag SRadNar SRadVn SWidth )
	(setq SRadNar nil)
	(setq SRadVn nil)
	(setq SWidth nil)
	(setq flag nil)

	(while (null flag)
		(initget 1 "")
		(setq SRadNar (getdist "\n   [  ]:"))
		(if (= SRadNar "") 
			(progn
				(setq SRadNar nil)
				(initget 1)
				(setq SRadVn (getdist "\n  :"))
 			)
		) 
		(if (null SRadVn)
			(progn
				(initget 1 "O")
				(setq SRadVn (getdist "\n   [O]:"))
				(if (= SRadVn "O")
					(progn
						(setq SRadVn nil)
						(initget 1)
						(setq SWidth (getdist "\O :"))
						(if (and (> SWidth 0) (> SRadNar 0)) (setq SRadVn (- SRadNar SWidth)))
					)
				)
			)
		)
		
		(if (null SRadNar)
			(progn
				(setq SRadNar nil)
				(initget 1 "O")
				(setq SRadNar (getreal "\n   [O]:"))
				(if (eq SRadNar "O")
					(progn
						(setq SRadNar nil)
						(initget 1)
						(setq SWidth (getdist "\O :"))
						(if (and (> SWidth 0) (> SRadVn 0)) (setq SRadNar(+ SRadVn SWidth)))
					)
				)

			)
		)
		(if (or (null SRadVn) (null SRadNar))
			(setq flag nill)
			(progn
				(if (< SRadNar SRadVn)
					(progn
						(princ (strcat "   (" (rtos SRadVn) ")      (" (rtos SRadNar) ")."))
						(setq SRadVn nil)
						(setq SRadNar nil)
						;(setq SWidth nil)
						(setq flag nill)
					)
					(if (> SWidth SRadNar)
						(progn
							(princ (strcat "   (" (rtos SRadNar) ")      (" (rtos SWidth) ")."))
							(setq flag nill)
							(setq SRadVn nil)
							(setq SRadNar nil)
							(setq SWidth nil)
						)
						(setq flag t)
					)
				)
			)
		)
	)
	(setq SRadDat (list SRadVn SRadNar))
	t SRadDat
)



;  
; 
(defun getSectXor ( SRadVn SRadNar / mode SXorType SAngle SXor SXor1 )
	(setq SAngle 0)
	(setq SXor1 0)
	(while (or (<= SAngle 0) (= SXor1 0))
		(setq SXor1 0)
		(initget 1 "")
		(setq mode 1)
		(setq SXorType (getdist "\n   [  ]:"))
		(if (= SXorType "") 
			(progn
				(setq Mode 0)
				(initget 1)
				(setq SXor (getdist "\n  :"))
				(setq SXor1 (/ SXor 2))
				(if (<= SXor1 SRadVn)
					(progn
						(setq SXor1 (/ SXor 2))
						(setq X (sqrt (- (* SRadVn SRadVn) (* SXor1 SXor1))))
						(if (= X 0) (setq SAngle 180))
						(if (> X 0) (setq SAngle (* 2 (/ (* (atan (/ SXor1 X)) 180) pi))))
					)
				)
				(if (> SXor1 SRadVn)
					(progn
						(setq SAngle 0)
						(princ (strcat "\n   (" (rtos (* SXor1 2)) ")       (" (rtos (* 2 SRadVn)) ")"))
					)
				)

			)
		)
		(if (and (= SAngle 0) (= Mode 1))
			(progn
				(setq SXor1 (/ SXorType 2))
				(if (<= SXor1 SRadNar)
					(progn
						(setq SXor1 (/ SXorType 2))
						(setq X (sqrt (- (* SRadNar SRadNar) (* SXor1 SXor1))))
						(if (= X 0) (setq SAngle 180))
						(if (> X 0) (setq SAngle (* 2 (/ (* (atan (/ SXor1 X)) 180) pi))))
					)
				)
				(if (> SXor1 SRadNar)
					(progn
						(setq SAngle 0)
						(princ (strcat "\n   (" (rtos (* SXor1 2)) ")       (" (rtos (* 2 SRadNar)) ")."))
					)
				)
			)
		)
	)
	t SAngle
)



;   
; 
(defun getSectLen ( SRadVn SRadNar / Mode SLenType SLen SAngle )
	(setq SAngle 0)
	(while (<= SAngle 0)
		(initget 1 "")
		(setq Mode 1)
		(setq SLenType (getreal "\n   [  ]:"))
		(if (= SLenType "") 
			(progn
				(setq Mode 0)
				(initget 1)
				(setq SLen (getreal "\n  :"))
				(if (< SLen (* 2 pi SRadVn))
					(setq SAngle (/ (* 180 SLen) (* pi SRadVn)))
				)
				(if (> SLen (* 2 pi SRadVn))
					(progn
						(princ (strcat "\n    (" (rtos SLen) ")         (" (rtos (* 2 pi SRadVn)) ")."))
					)
				)
			)
		)
		(if (and (= Mode 1) (<= SAngle 0))
			(progn
				(if (< SLenType (* 2 pi SRadNar))
					(setq SAngle (/ (* 180 SLenType) (* pi SRadNar)))
				)
				(if (> SLenType (* 2 pi SRadVn))
					(progn
						(princ (strcat "\n    (" (rtos SLenType) ")         (" (rtos (* 2 pi SRadNar)) ")."))
					)
				)
			)
		) 
	)
	t SAngle
)



; 
; 
	
	;    
	;    
	;SRadNar -   
	;SRadVn -   
	;SAngle -  

(defun DrawSect ( BasePt SRadNar SRadVn SAngle 
                / bpx bpy bpz dx dy SCentPT SAngle1 
                  pt1 pt2 pt3 pt4 pt5 pt6 S1)
	
	($Osnap_Off)
	
	;       bp
	(setq bpx (car BasePt))
	(setq bpy (cadr BasePt))
	(setq bpz (caddr BasePt))
	
	(setq dy (* SRadNar (cos (/ (dtr SAngle) 2))))
	(if (< SAngle 180.0)
		(progn
			(setq dx (* SRadNar (sin (/ (dtr SAngle) 2)))) 
			(setq dy (- dy (* (cos (/ (dtr SAngle) 2)) (- SRadNar SRadVn))))
			(setq dy (- dy))
		)
		(progn
			(setq dx SRadNar)
			(setq dy (* (sin (- (/ (dtr SAngle) 2) (dtr 90.0) )) SRadNar))
		)	
	)
		
	(setq SCentPT (list (+ bpx dx) (+ bpy dy) (+ bpz 0)))	; 
															;
	
	;  
	(setq SWidth (- SRadNar SRadVn))	; 

	(setq SAngle1 (dtr (/ SAngle 2))) 	;  
										; 
										
	; 
	(setq pt1 (polar SCentPT (+ (dtr 90) SAngle1) SRadVn))
	(setq pt2 (polar SCentPT (dtr 90) SRadVn))
	(setq pt3 (polar SCentPT (- (dtr 90) SAngle1) SRadVn))
	(setq pt4 (polar SCentPT (- (dtr 90) SAngle1) SRadNar))
	(setq pt5 (polar SCentPT (dtr 90) SRadNar))
	(setq pt6 (polar SCentPT (+ (dtr 90) SAngle1) SRadNar))
	
	(setq S1 nil)
	(setq S1 (ssadd))
	(command "_Pline"
		pt1
		"_Arc" "_Second"
		pt2
		pt3
		"_Line"
		pt4
		"_Arc" "_Second"
		pt5
		pt6
		"_Line"
		"_CLose"
	)
	(ssadd (entlast) S1)
	
	($Osnap_On)
	
	T S1
)





;   
; ,     
;   : SectorA
(defun C:SectorA ( / SRDat SAngle SRadNar SRadVn SWidth flag S1 bp bp1 bp2 SectObj)
	(SetOpt)
	
	;(setq SRadNar 0)
	;(setq SRadVn 0)
	;(setq SWidth 0)
	(setq SAngle 0)
	
	(setq SRDat (getSectRad))
	(setq SRadVn (car SRDat))
	(setq SRadNar (cadr SRDat))
	
	(while (or (= SAngle 0) (>= SAngle 360))
		(setq HelpTXT (strcat "\n   : "))
		(initget 1)
		(setq SAngle (getangle HelpTXT))
		(setq SAngle (* 180 (/ SAngle pi)))
		(if (>= SAngle 360)
			(progn
				(princ (strcat "\n   (" (rtos SAngle) ")       360 ."))
				(setq SAngle 0)
			)
		)
	)
	
	(SetOpt)
	
	(setq flag nil)
    (setq S1 nil)
	(setq S1 (ssadd))
	(setq bp (grread T (+ 1 4) 0))	;   
	(if (= 5 (car bp))		;      
							;    
		(progn
			(setq bp1 (car (cdr bp)))
			(setq SectObj (DrawSect bp1 SRadNar SRadVn SAngle))	;
																;
		)
	)
	(princ "\n : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	;      
							;    
			(progn
				(setq bp2 (car (cdr bp)))
				(command "_erase" SectObj "")	; 
    			(setq SectObj nil)
				(setq SectObj (ssadd))
				;    
				(setq SectObj (DrawSect bp2 SRadNar SRadVn SAngle))
			)
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
				(setq flag T)
		)
	)
	T bp2
	($Osnap_Off)
	(RotateObj SectObj bp2)	; 
	($Osnap_On)
	($RetOpt)
)


;   
; ,     
;   : SectorX
(defun C:SectorX ( / SRDat SRadNar SRadVn SXor SAngle SWidth flag S1 bp bp1 bp2 SectObj)
	(SetOpt)
	
	;(setq SRadNar 0)
	;(setq SRadVn 0)
	;(setq SXor 0)
	;(setq SAngle 0)
	;(setq SWidth 0)
	
	(setq SRDat (getSectRad))
	(setq SRadVn (car SRDat))
	(setq SRadNar (cadr SRDat))
	
	(setq SAngle (getSectXor SRadVn SRadNar))
	
	(SetOpt)
	
	(setq flag nil)
    (setq S1 nil)
	(setq S1 (ssadd))
	(setq bp (grread T (+ 1 4) 0))	;   
	(if (= 5 (car bp))		;      
							;    
		(progn
			(setq bp1 (car (cdr bp)))
			(setq SectObj (DrawSect bp1 SRadNar SRadVn SAngle))	;
																;
		)
	)
	(princ "\n : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	;      
							;    
			(progn
				(setq bp2 (car (cdr bp)))
				(command "_erase" SectObj "")	; 
    			(setq SectObj nil)
				(setq SectObj (ssadd))
				;    
				(setq SectObj (DrawSect bp2 SRadNar SRadVn SAngle))
			)
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
				(setq flag T)
		)
	)
	T bp2
	($Osnap_Off)
	(RotateObj SectObj bp2)	; 
	($Osnap_On)
	($RetOpt)
)


;   
; ,      
;   : SectorL
(defun C:SectorL ( / SRDat SRadNar SRadVn SXor SAngle SWidth flag S1 bp bp1 bp2 SectObj)
	(SetOpt)
	
	;(setq SRadNar 0)
	;(setq SRadVn 0)
	;(setq SLen 0)
	;(setq SAngle 0)
	;(setq SWidth 0)
	
	(setq SRDat (getSectRad))
	(setq SRadVn (car SRDat))
	(setq SRadNar (cadr SRDat))

	
	(setq SAngle (getSectLen SRadVn SRadNar))
	
	(SetOpt)
	
	(setq flag nil)
    (setq S1 nil)
	(setq S1 (ssadd))
	(setq bp (grread T (+ 1 4) 0))	;   
	(if (= 5 (car bp))		;      
							;    
		(progn
			(setq bp1 (car (cdr bp)))
			(setq SectObj (DrawSect bp1 SRadNar SRadVn SAngle))	;
																;
		)
	)
	(princ "\n : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	;      
							;    
			(progn
				(setq bp2 (car (cdr bp)))
				(command "_erase" SectObj "")	; 
				(setq SectObj nil)
				(setq SectObj (ssadd))
				;    
				(setq SectObj (DrawSect bp2 SRadNar SRadVn SAngle))
			)
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
			(setq flag T)
		)
	)
	
	($Osnap_Off)
	T bp2
	(RotateObj SectObj bp2)		; 
	($Osnap_On)
	($RetOpt)
)

;=============================================================
(princ "\n     SectorA  ")
(princ "\n     SectorX  ")
(princ "\n     SectorL  ")
(princ)
