;;;--------------------------------------------------------------------;;;
;;;           "", ""  ..         ;;;
;;;                     Slit.lsp Version 4.3                           ;;;
;;;                 AutoCAD r13-15 for Windows                      ;;;
;;;                          30.04.2002                                ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;                    E-Mail: tb5@ugm.zsmk.ru                         ;;;
;;;--------------------------------------------------------------------;;;

;;                                                              
;;     :                       
;;	1.       : Arrow   
;;	2.    " ": ViewAr                     
;;	3.   "": Slit                       
;;  4.     " ": ViewDis           
;;  5.      "-": SlitDis         
;;                                                              

;;                                                              
;;          
;;  AutoCAD  :                          
;;       Slit.lsp                                               
;;       ViewDis.dcl                                            
;;       ESKD_Sym.shx                                           
;;       ViewDis.slb                                            
;;

    ;                                                           
    ;   4.3      
    ;    "".                              
    ;                                                           
    ;                                                           
    ;   4.2   .                
    ;                                                           
    ;   4.1   .                
    ;       AutoCAD.
    ;    AutoCAD 2000 (15)  ,      
    ;      
    ; CELWEIGHT,     .        
    ;  AutoCAD   ,       
    ;    CELWEIGHT  , . .   
    ;             
    ;    AutoCAD    2000 (15)   
    ;                                                           
    ;  ,   4.1    ViewDis       
    ; SlitDis    .                     
    ;                                                           

	;                               
	;   DIMSCALE (  )
	;  ,    ,  - 
	;   1,        
	;             
	; Scale to Paper Space ,       
	;          
	;                                                  
	;    - CONTINUOUS                              
	;                                  
	;   DIMCLRD (  )       
	;                              
	;   DIMLWD (  )         
	
	;!!!                                                      
	;               
	;      0.0,     
	;      1.2        
	;  (   ),   
	;              
	;                           
	
	;  ,                        
	; Scale to Paper Space ,             
	;                
	; .               
	;    ,    ,        
	;    ,       
	;                                                            

;=============================================================

    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        ;   
        ($RetOpt)
        ($Osnap_On)
        ($RetLProp)
        (GC)
        (setvar "FILEDIA" 1)
        (if msg (princ "\n ESKD_Sym.shx   " ))
    )

;   ESKD_Sym.shx
    (setq old_fdia (getvar "FILEDIA"))
    (setvar "FILEDIA" 0)
    (command "_load" "ESKD_Sym")
    (setvar "FILEDIA" old_fdia)

    (if old_error (setq *error* old_error))

;=============================================================
;;;  
;;   ($cmsf)****
(defun $cmsf (/ ent elist mvscale)
    (if	(= 0 (getvar "tilemode"))
        (progn
	        (if (setq ss1
	                (ssget "X" (list '(0 . "VIEWPORT") (cons 69 (getvar "cvport"))))
	            ) ;_ end of setq
	            (setq ent (ssname ss1 0))
	        ) ;_end of if
	        (setq mvscale ($msf ent)
	              my mvscale)
        )	;_end of progn tilemode /= 1
        (if (= 0 (getvar "dimscale"))
            (setq my nil)
            (setq my (getvar "dimscale"))
        )
    )	;_ end if tilemode = 0
) ;_ end of defun

(defun $msf (ent / vpxdata ms_height ps_height $msf entxdata)
    (defun entxdata (ent appid / d)
        (if (and (setq d (entget ent (list appid)))
	             (setq d (assoc -3 d))
	             (cdadr d)
	        ) ;_ end of and
	         (cdadr d)
        ) ;_ end of if
    ) ;_ end of defun
    (setq vpxdata   (entxdata ent "acad")
	      ms_height (cdr (nth 6 vpxdata))
	      ps_height (cdr (assoc 41 (entget ent)))
    ) ;_ end of setq
    (/ ms_height ps_height)
  ) ;_ end of defun $msf

;;****

;    
(defun get_Scale ( / ret_Sc)
    ($cmsf) 
    (setq ret_Sc my) 
    t ret_Sc
)

;         
(defun UnBlock ( pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName )
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;    
(defun SetOpt ()
; 
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

(defun $RetOpt ()
; 
	(if sblip (setvar "BLIPMODE" sblip))
	(if scmde (setvar "CMDECHO" scmde))
)

(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	    ;  
	(setq oldLType (getvar "CELTYPE"))	    ;   
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setq oldWeight (getvar "CELWEIGHT"))	;  
	)
)

(defun $RetLProp ()
;   
	(if oldColor (setvar "CECOLOR" oldColor))
	(if oldLType (setvar "CELTYPE" oldLType))
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
		(if oldWeight (setvar "CELWEIGHT" oldWeight))
	)
)

;  OSNAP
(defun $Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun $Osnap_On  ()
	(if sosnapm (setvar "OSMODE" sosnapm))
)

;-------------------------------------------------------------

;     
(defun dtr (Ang)
	(/ (* Ang pi) 180)
)

;     
(defun rtd (Ang) 
	 (* Ang (/  180 pi))
)

;  
(defun tan (Ang)
	(setq tangens (/ (sin Ang) (cos Ang)))
	T tangens
)

;-------------------------------------------------------------

;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)


(defun InsTxt (pt Ang Txt HTxt Just / CurTxtStyle sth )
	(if (not (null Txt)) ;   
        (progn
            (setq CurTxtStyle (getvar "TEXTSTYLE")) ;   
	        (setq sth (cdr (assoc 40 (tblsearch "style" CurTxtStyle)))) ;      
            (if (null Just) ;   
                (if (= sth 0.0) 
     		        (command "_text" pt HTxt Ang Txt)
				    (command "_text" pt Ang Txt)
			    )
                (if (= sth 0.0) 
     		        (command "_text" "_Justify" Just pt Htxt Ang Txt)
				    (command "_text" "_Justify" Just pt Ang Txt)
			    )
            )
        )
    )
)

;        sp
;   GX  GY,      
;   sp  xX b dY
(defun drw_boxC (sp GX GY dX dY / p1 p2 p3 p4)
    (command "'_redraw")
    (setq p1 (polar sp (dtr 180) dX))
    (setq p1 (polar p1 (dtr 270) dY))
    (setq p2 (polar p1 (dtr 0) GX))
    (setq p3 (polar p1 (dtr 90) GY))
    (setq p4 (polar p3 (dtr 0) GX))
    (grdraw p1 p2 1)
    (grdraw p2 p4 1)
    (grdraw p4 p3 1)
    (grdraw p3 p1 1)
)

;   
(defun get_ins_PointC (GX GY dX dY / flag bp bp1)
    
    (setq flag nil)
    (princ "\n : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	            ;      
							            ;    
			(progn
				(setq bp1 (car (cdr bp)))
            	(drw_boxC bp1 GX GY dX dY)
            	
            )
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
	        (setq flag T)
		)
	)
	
	(command "'_redraw")
    t bp1
)


;;;   
;=============================================================


;;; 
;=============================================================
;      
(defun drwArrow (sp	ep scale 
                 / ArAng ArL ArW ArWD ArCOL ArWD)
;sp -   
;ep -  
;scale -  
	(setq ArAng (angle sp ep))	; 
	(setq ArL 4.0)	; 
	(setq ArW 1.6)	; 
	(setq ArCOL (getvar "DIMCLRD"))	; , - 
									;  

	(if (not (< (atof (getvar "ACADVER")) 15))
		(setq ArWD (getvar "DIMLWD"))	;  , - 
										;  
	)

	
;	(if (= (getvar "TILEMODE") 0)   ;   
;		(setq scale 1)
;	)
    (setq Scale (get_Scale))
	;  
	($SaveLProp)	
	(setvar "CECOLOR" (rtos ArCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
	
	(setq pt1 (polar ep (- ArAng (dtr 180)) (* ArL scale)))
	(setq pt2 (polar pt1 (+ ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	(setq pt1 (polar pt1 (- ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	
	(setq S2 nil)
	(setq S2 (ssadd))
	($Osnap_Off)
	(command "_Line" sp ep "")
	(ssadd (entlast) S2)
	(command "_Solid" pt1 pt2 ep ep "")
	(ssadd (entlast) S2)
	($Osnap_On)
	
	;  
	($RetLProp)
	T S2	;     
)

;       
;  ,   
(defun drwTxtHorUpArr (TxtUpAr sp ep ptTxt Scale
                       / ArAng ArWD
                         pt2 
                         CurTxtStyle th TxtCOL TxtH)
	;TxtUpAr - 
	;sp -   
	;ep -   
	;ptTxt -      

	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     

	(setq ArAng (angle sp ep))	; 
	(setq TxtCOL (getvar "DIMCLRD"))	; , - 
										;  
	(setq TxtH (* 1.2 (getvar "DIMTXT") Scale))	;  
											    ;   * 1.2
	(if (not (< (atof (getvar "ACADVER")) 15))
		(setq ArWD (getvar "DIMLWD"))	;  , - 
										;  
	)
	
;	(if (= (getvar "TILEMODE") 0)   ;   
;		(setq scale 1)
;	)
    (setq Scale (get_Scale))
    
	;  
	($SaveLProp)						
	(SETVAR "CECOLOR" (RTOS TXTCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
	($Osnap_Off)
	(if (and (>= ArAng 0.0) (> (dtr 90) ArAng))
		(progn
			(setq pt2 (polar ptTxt (+ ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_Right" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_Right" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (= ArAng (dtr 90))
		(progn
			(setq pt2 (polar ptTxt 0.0 (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_TL" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_TL" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (and (> ArAng (dtr 90)) (>= (dtr 180) ArAng))
		(progn
			(setq pt2 (polar ptTxt (+ ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_BL" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_BL" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (and (> ArAng (dtr 180)) (> (dtr 270) ArAng))
		(progn
	(princ)
			(setq pt2 (polar ptTxt (- ArAng (dtr 90)) (* Scale 1.0)))
			(setq pt2 (polar pt2 (- ArAng (dtr 180)) (* Scale (cos ArAng) TxtH (- 0.3))))
			(if (= th 0.0)
				(command "_text" "_Justify" "_Right" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_Right" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (= ArAng (dtr 270))
		(progn
			(setq pt2 (polar ptTxt (- ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_Right" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_Right" pt2 0.0 TxtUpAr)
			)
		)
	)

	(if (and (> ArAng (dtr 270)) (> (dtr 360) ArAng))
		(progn
			(setq pt2 (polar ptTxt (+ ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_BL" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_BL" pt2 0.0 TxtUpAr)
			)
		)
	)
	($Osnap_On)

	;  
	($RetLProp)

)

;   
; 
(defun drwSlitEndLin (sp ep scale
                      / pt1 pt2 pt3 pt4
                        LinAng LinCOL LinL LinW
                        ArWD)
	;sp -   
	;ep -  
	;scale -  

	;
	;           sp
	;  pt2     /         pt4          ep
	;   +*****/*********+            /
	;   *****+***********           +
	;   +***************+
	;  pt1               pt3
	;

	(setq LinAng (angle sp ep))				; 
	(setq LinCOL (getvar "DIMCLRD"))		; , - 
											;  
	(setq LinL 7.0)						; 
	(setq LinW 0.8)							; 
	(if (not (< (atof (getvar "ACADVER")) 15))
		(setq ArWD (getvar "DIMLWD"))	;  , - 
										;  
	)

;	(if (= (getvar "TILEMODE") 0)   ;   
;		(setq scale 1)
;	)
    (setq Scale (get_Scale))
    
	;  
	($SaveLProp)						
	(SETVAR "CECOLOR" (RTOS LINCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
	
	; 
	(setq pt1 (polar sp (- LinAng (dtr 180)) (* scale 0.3 LinL)))
	(setq pt1 (polar pt1 (- LinAng (dtr 90)) (* scale 0.5 LinW)))
	(setq pt2 (polar pt1 (+ LinAng (dtr 90)) (* scale LinW)))
	(setq pt3 (polar pt1 LinAng (* scale LinL)))
	(setq pt4 (polar pt2 LinAng (* scale LinL)))
	;  
	
	;
	($Osnap_Off)
	(command "_Solid" pt1 pt2 pt3 pt4 "")
	(ssadd (entlast) SelObj)	
	($Osnap_On)
	; 
	
	;  
	($RetLProp)
)

;    
(defun drwSlitMidLin (sp mp ep scale
                      / pt1 pt2 pt3 pt4 pt5 pt6
                        LinAngS LinAngE LinCOL LinL
                        ArWD)
	;sp -   
	;mp -   
	;ep -  
	;scale -  

	;
	;
	;		  sp	pt1		   pt3
	;		 /	     +********+
	;		+	     ********+*
	;			     +******+*\
	;			    pt2  pt4***\
	;			            *** mp
	;			            ***
	;			            ***
	;			            +*+
	;          		     pt6   pt5
	;            
	;						 +
	;						  \
	;						   ep
	;

	(setq LinAngS (angle mp sp))			;  
	(setq LinAngE (angle mp ep))			;  
	(setq LinCOL (getvar "DIMCLRD"))		; , - 
											;  
	(setq LinL 4.0)							;     
											;  
	(setq LinW 0.8)							; 
	(if (not (< (atof (getvar "ACADVER")) 15))
		(setq ArWD (getvar "DIMLWD"))	;  , - 
										;  
	)

;	(if (= (getvar "TILEMODE") 0)   ;   
;		(setq scale 1)
;	)
    (setq Scale (get_Scale))
    
	;  
	($SaveLProp)						
	(SETVAR "CECOLOR" (RTOS LINCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
	
	; 
	(setq pt1 (polar mp LinAngS (* scale LinL)))
	(setq pt1 (polar pt1 (- LinAngS (dtr 90)) (* scale 0.5 LinW)))
	(setq pt2 (polar pt1 (+ LinAngS (dtr 90)) (* scale LinW)))
	
	(setq pt5 (polar mp LinAngE (* scale LinL)))
	(setq pt5 (polar pt5 (+ LinAngE (dtr 90)) (* scale 0.5 LinW)))
	(setq pt6 (polar pt5 (- LinAngE (dtr 90)) (* scale LinW)))

	(setq pt3 (polar pt1 (- LinAngS (dtr 180)) (* scale (+ LinL (* 0.5 LinW (tan (/ (- (dtr 180) (- LinAngE LinAngS)) 2)))))))
	(setq pt4 (polar pt2 (- LinAngS (dtr 180)) (* scale (+ LinL (* 0.5 LinW (tan (/ (- (dtr 180) (- LinAngS LinAngE)) 2)))))))
	
	;  
	
	;
	($Osnap_Off)
	(command "_Solid" pt1 pt2 pt3 pt4 "")
	(ssadd (entlast) SelObj)	
	(command "_Solid" pt3 pt4 pt5 pt6 "")
	(ssadd (entlast) SelObj)
	($Osnap_On)
	; 
	
	;  
	($RetLProp)
)

;    
(defun drwSlitArTxt (cp pp dAng SlitDis scale
                     / ep sp
                       ArAng ArL ArW ArCOL ArWD
                       pt1 pt2 ptTxt
                       Jut TxtH CurTxtStyle th)
	;cp -   
	;pp -   
	;ArAng -   (90  -90 )
	;SlitDis -  
	;scale -  

	;
	;					   cp
	;  pp				  /
	;  \	*************/****
	;	+	************+*****
	;		******************
	;					+---ep
	;				   ***
	;				   ***
	;				  * * *
	;				  * * *
	;		  			*
	;		 			*
	;					*     PtTxt
	;					*    /
	;					*	+
	;					*
	;					+**sp
	;
	
	(setq SlitAng (angle cp pp))			;  

;	(if (= (getvar "TILEMODE") 0)   ;   
;		(setq scale 1)
;	)
    (setq Scale (get_Scale))

	
	(setq ep (polar cp (+ SlitAng (dtr dAng)) (* 0.4 scale)))
	(setq sp (polar ep (+ SlitAng (dtr dAng)) (* 10.0 scale)))
	

	(setq ArAng (angle sp ep))			; 
	(setq ArL 4.0)						; 
	(setq ArW 1.6)						; 
	(setq ArCOL (getvar "DIMCLRD"))		; , - 
										;  
	(if (not (< (atof (getvar "ACADVER")) 15))
		(setq ArWD (getvar "DIMLWD"))	;  , - 
										;  
	)


	;  
	($SaveLProp)						
	(setvar "CECOLOR" (rtos ArCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(if (not (< (atof (getvar "ACADVER")) 15)) ;   AutoCAD   15.0
	    (setvar "CELWEIGHT" ArWD)
	)
		
	; 
	(setq pt1 (polar ep (- ArAng (dtr 180)) (* ArL scale)))
	(setq pt2 (polar pt1 (+ ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	(setq pt1 (polar pt1 (- ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	;  
	(setq PtTxt (polar sp ArAng (* scale 5.0)))
	(setq ptTxt (polar ptTxt (- SlitAng (dtr 180)) (* scale ArW)))
	
	;
	($Osnap_Off)
	
	(command "_Line" sp ep "")
	(ssadd (entlast) SelObj)
	(command "_Solid" pt1 pt2 ep ep "")
	(ssadd (entlast) SelObj)
	
	;
	(setq Jut 1)
	(setq SlitAng (round SlitAng 4))
	(setq ArAng (round ArAng 4))
	(if (= 0.0 ArAng)
		(if (= SlitAng (round (dtr 90) 4))
			(setq Jut "_TR")
			(setq Jut "_Right")
		)
	)
	
  (if (= Jut 1)
	(if (and (< 0.0 ArAng) (< ArAng (round (dtr 90) 4)))
		(if (and (< (round (dtr 90) 4) SlitAng) (< SlitAng (round (dtr 180) 4)))
			(setq Jut "_TL")
			(setq Jut "_Right")
		)
	)
  )
  (if (= Jut 1)
	(if (= (round (dtr 90) 4) ArAng)
		(if (= SlitAng (round (dtr 180) 4))
			(setq Jut "_TL")
			(setq Jut "_TR")
		)
	)
  )

  (if (= Jut 1)
	(if (and (< (round (dtr 90) 4) ArAng) (< ArAng (round (dtr 180) 4)))
		(if (and (< (round (dtr 180) 4) SlitAng) (< SlitAng (round (dtr 270) 4)))
			(setq Jut "_BL")
			(setq Jut "_TR")
		)
	)
  )
  
  (if (= Jut 1)
	(if (= (round (dtr 180) 4) ArAng)
		(if (= SlitAng (round (dtr 270) 4))
			(setq Jut "_BL")
			(setq Jut "_TL")
		)
	)
  )

  (if (= Jut 1)
	(if (and (< (round (dtr 180) 4) ArAng) (< ArAng (round (dtr 270) 4)))
		(if (and (< (dtr 270) SlitAng) (<= SlitAng (dtr 360)))
			(setq Jut "_BL")
			(setq Jut "_TL")
		)
	)
  )

  (if (= Jut 1)
	(if (= (round (dtr 270) 4) ArAng)
		(if (or (= SlitAng 0.0) (= SlitAng (round (dtr 360) 4)))
			(setq Jut "_Right")
			(setq Jut 2)
		)
	)
  )

  (if (= Jut 1)
	(if (and (< (round (dtr 270) 4) ArAng) (< ArAng (round (dtr 360) 4)))
		(if (and (< 0.0 SlitAng) (< SlitAng (round (dtr 90) 4)))
			(setq Jut "_TR")
			(setq Jut "_BL")
		)
	)
  )
  (if (= Jut 1)
    (setq Jut "_BL")
  )
	(setq TxtH (* 1.2 (getvar "DIMTXT") Scale))	;  
                                                        ;   * 1.2
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
	(if (= th 0.0)
		(if (not (= Jut 2))
		    (command "_text" "_Justify" Jut PtTxt TxtH 0.0 SlitDis)
		    (command "_text" PtTxt TxtH 0.0 SlitDis)
		)
		(if (not (= Jut 2))
		    (command "_text" "_Justify" Jut PtTxt 0.0 SlitDis)
		    (command "_text" PtTxt 0.0 SlitDis)
		)
	)
	
	($Osnap_On)
	; 
	
	;  
	($RetLProp)
)



;   
(defun $ViewDis ( VDis f_DO f_M M1 M2 / pt CurTxtStyle th TxtPoints pt1 SymL Jut Scale pt2 GX GY dX dY)
    (setq Scale (get_Scale)) ;  
	(setq th (* (getvar "DIMTXT") Scale))	;  
											;  
    (setq th (* th 1.2))
    (setq TxtPoints (textbox (list (cons 1 VDis) (cons 40 th))) )
    (setq pt1 (cadr TxtPoints) )
    (setq SymL (car pt1))
    
    ;(setq pt (getpoint "\n   : "))
    (if (not (= f_M 0)) ;    
        (progn
            (setq GY (+ th (/ th 1.1) (* 5 Scale)))
            (setq dY (+ (/ th 1.2) (* Scale 4)))
        )
        (progn
            (setq GY (+ th (* 4 Scale)))
            (setq dY (* 3 Scale))
        )
    )
    (if (not (= f_DO 0)) ;    
        (if (= f_DO 1)
            (setq GX (+ SymL (* 2 Scale) (* 7 Scale)))
            (setq GX (+ SymL (* 2 Scale) (* 9 Scale)))
        )
        (setq GX (+ SymL (* 2 Scale)))
    )
    
    (setq dX (+ (/ SymL 2) (* 1 Scale)))
    (setq pt (get_ins_PointC GX GY dX dY))
    ($SaveLProp)
    ($setLTypeDim)
    (if (not (= f_M 0)) ;     
        (if (not (= f_DO 0)) ;    
            (if (= f_DO 1)
                (progn ;     ""
                    (InsTxt pt 0 VDis th "_Center")
                    (command "_shape" "ROT" (polar pt 0 (+ (/ SymL 2) (* 2 Scale))) scale (rtd 0))
                    (setq th (/ th 1.2))
                    (InsTxt (polar pt (dtr 270) (+ th 3)) 0 (strcat "M " M1 ":" M2) th "_Center")
                ;(command "_insert" "VD_RotM" pt Scale "" "0" (strcat "M " M1 ":" M2) VDis)                
                )
                (progn ;     ""
                    (InsTxt pt 0 VDis th "_Center")
                    (command "_shape" "UNROLL" (polar pt 0 (+ (/ SymL 2) (* 2 Scale))) scale (rtd 0))
                    (setq th (/ th 1.2))
                    (InsTxt (polar pt (dtr 270) (+ th 3)) 0 (strcat "M " M1 ":" M2) th "_Center")
                ;(command "_insert" "VD_UnrollM" pt Scale "" "0" (strcat "M " M1 ":" M2) VDis)                
                )
            ) ; end (if (= f_DO 1)
            (progn
                (InsTxt pt 0 VDis th "_Center")
                (setq th (/ th 1.2))
                (InsTxt (polar pt (dtr 270) (+ th 3)) 0 (strcat "M " M1 ":" M2) th "_Center")
                ;(command "_insert" "VD_M" pt Scale "" "0" (strcat "M " M1 ":" M2) VDis)
            )
        ) ; end(if (not (= f_DO 0))
        (if (not (= f_DO 0)) ;    
            (if (= f_DO 1)
                (progn ;     ""
                    (InsTxt pt 0 VDis th "_Center")
                    (command "_shape" "ROT" (polar pt 0 (+ (/ SymL 2) (* 2 Scale))) scale (rtd 0))
                ;(command "_insert" "VD_RotM" pt Scale "" "0" (strcat "M " M1 ":" M2) VDis)                
                )
                (progn ;     ""
                    (InsTxt pt 0 VDis th "_Center")
                    (command "_shape" "UNROLL" (polar pt 0 (+ (/ SymL 2) (* 2 Scale))) scale (rtd 0))
                ;(command "_insert" "VD_UnrollM" pt Scale "" "0" (strcat "M " M1 ":" M2) VDis)                
                )
            ) ; end (if (= f_DO 1)
            (InsTxt pt 0 VDis th "_Center")
        ) ; end(if (not (= f_DO 0))
    ) ; end (if (not (= f_M 0))
    ($RetLProp)
    ;($Osnap_On)
)


;;;  
;=============================================================


;;;    
;=============================================================
;      
(defun C:Arrow ( / ArStart ArEnd 
                   SelObj blkName)
	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	

	;       

	(SetOpt)
	(initget 1)
	(setq ArStart (getpoint "\n  : "))
	(initget 1)
	(setq ArEnd (getpoint ArStart "\n  : "))
	(While (equal ArStart ArEnd)
		(prompt  "\n:      ")
		(initget 1)
		(setq ArEnd (getpoint ArStart "\n  : "))
	)

	(setq SelObj (drwArrow ArStart ArEnd (get_Scale)))
	
	(UnBlock ArEnd SelObj)
	
    (prin1)
    (setq SelObj nil)
	(prin1)
	($RetOpt)
)

;  " X"
(defun C:ViewAr ( / Scale Vsp VAng Vep Vmp VTxt SelObj blkName)
	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     

	;       


	;
	;
	;		  *
	;		 * *
	;		*   *
	;		*****
	;		*   *  **
	;                **
	;	*****************
	;                **
	;			   **
	;				
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     

    (setq Scale (get_Scale))
	(initget 1)
	(setq Vsp (getpoint "\n  : "))
	(initget 1)
	(setq VAng (getangle Vsp "\n : "))
	(setq Vep (polar Vsp Vang (* Scale 10.0)))
	(setq Vmp (polar Vsp VAng (* 5 Scale)))
	
	(setq SelObj (drwArrow Vsp Vep Scale))
	
	(UnBlock Vep SelObj)
	
	(setq SelObj nil)
	(setq VTxt nil)
	(While (or (null VTxt) (= VTxt ""))
		(setq VTxt (getstring "\n  <A>: "))
		(if (or (null VTxt) (= VTxt ""))
			(setq VTxt "")
		)
	)
	(drwTxtHorUpArr VTxt Vsp Vep Vmp Scale)
)

;  
(defun C:Slit ( / Sc SelObj StartPt MidPt SecondPt pppt ppt NextPt 
                  oldUCSICON ArPt CAng AAng dArAng CTxt blkName)
	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
    ;       
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     

    (setq Sc (get_Scale))
    (setq Scale Sc)
    
	(setq SelObj nil)
	(setq SelObj (ssadd))
	
	(initget 1)
	(setq StartPt (getpoint "\n  : "))
	(initget 1)
	(setq MidPt (getpoint StartPt "\n  : "))
	(drwSlitEndLin StartPt MidPt Sc)
	(setq SecondPt MidPt)
	(setq pppt StartPt)
	(setq ppt MidPt)
	(setq NextPt T)
	(while (/= NextPt nil) 
		(setq NextPt (getpoint ppt "\n  : "))
		(if (/= NextPt nil)
			(progn
				(drwSlitMidLin pppt ppt NextPt Sc)
				(setq pppt ppt)
				(setq ppt NextPt)
			)
			(progn
				(setq EndPt ppt)
				(drwSlitEndLin EndPt pppt Sc)
				
				($Osnap_Off)
				(setq oldUCSICON (getvar "UCSICON"))
				(setvar "UCSICON" 0)
				(command "_ucs" "_3point" EndPt pppt "")
				(setq oldOrthmode (getvar "ORTHOMODE"))
				(setvar "ORTHOMODE" 1)
				
				(SETQ old_error *error*) 
                (DEFUN *error* ( msg )
                    (if old_error (setq *error* old_error))
                    (if msg (princ "\n   " ))
                    ;   
				    ($Osnap_On)
				    (setvar "ORTHOMODE" oldOrthmode)
				    (COMMAND "_ucs" "_P")
				    (setvar "UCSICON" oldUCSICON)
                    (GC)
                )

				(setq ArPt (getpoint (list 0.0 0.0) "    ? "))
				(setq CAng (angle (list 0.0 0.0) pppt))
				(setq AAng (angle (list 0.0 0.0) ArPt))

				(if (and (<= 0 CAng) (<= CAng (dtr 180)))
					(if (and (<= CAng AAng) (< AAng (+ CAng (dtr 180))))
						(setq dArAng 90)
						(setq dArAng (- 90))
					)
				)

				(if (and (< (dtr 180) CAng) (< CAng (dtr 360)))
					(if (and (< (- CAng (dtr 180)) AAng) (<= AAng CAng))
						(setq dArAng (- 90))
						(setq dArAng 90)
					)
				)
				(setq CTxt nil)
				(While (or (null CTxt) (= CTxt ""))
					(setq CTxt (getstring "\n  <A>: "))
					(if (or (null CTxt) (= CTxt ""))
						(setq CTxt "")
					)
				)
				($Osnap_On)
				(setvar "ORTHOMODE" oldOrthmode)
				(COMMAND "_ucs" "_P")
				(setvar "UCSICON" oldUCSICON)
				;   
				(drwSlitArTxt EndPt pppt dArAng CTxt Sc)
				(setq dArAng (* (- 1) dArAng))
				(drwSlitArTxt StartPt SecondPt dArAng CTxt Sc)
			)
		)
		
 	)

	;       EndPt
    (UnBlock EndPt SelObj)

	(setq SelObj nil)
	;    
)


;     " "
(defun C:ViewDis ( / VDis f_DO f_M M1 M2)
	
    ;
    ;		***         **     *    
    ;		*  * *  *     *   * *   
    ;		***  *  *   ***  *   *  
    ;		*  * *  *  *  *  *****  
    ;		***   ** *  **   *   *  
    ;                               
    ;	  **************************
    ;				                
	
	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     

    (setq dcl_id (load_dialog "ViewDis.dcl"))
    (if (not (new_dialog "ViewDis" dcl_id))     ;   .
        (exit)                                  ; ,     
                                                ;   .
    )

    (action_tile "accept" "(bad_par_ViewDis)")
    
    (action_tile "chk_DO" "(act_chk_DO)")
    (action_tile "chk_M" "(act_chk_M)")
    (action_tile "opt_Rot" "(act_chk_M)")
    (action_tile "opt_Unroll" "(act_chk_M)")
    
    (im_ImgBoot "img_VD" "ViewDis(VD_)" 0 )
    (set_tile "txt_VD" "A")
    (setq VDis "A")
    (setq f_DO 0)
    (setq f_M 0)

    (action_tile "Ok" "(done_dialog 1)")
    (action_tile "cancel" "(done_dialog 0)")

    ;       "Ok" -  
    (if ( = 1 (start_dialog))
      (progn
            (unload_dialog dcl_id)
            ($ViewDis VDis f_DO f_M M1 M2)
      )
      (unload_dialog dcl_id)
    ) ; if       "Ok" -  
    
)

;     "-"
(defun C:SlitDis ( / SDis f_DO f_M M1 M2)
	
    ;
    ;
    ;		  *         *
    ;		 * *       * *
    ;		*   *     *   *
    ;		***** *** *****
    ;		*   *     *   *
    ;
    ;	  *******************
    ;				
	
	;     
	;   DIMSCALE (  )
	;  ,    ,  -
	;   1,      
	;         
	; Scale to Paper Space ,   
	;       
	; 
	;    - CONTINUOUS
	;    
	;   DIMCLRD (  )
	;     
	;   DIMLWD (  )
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     
    (setq dcl_id (load_dialog "ViewDis.dcl"))
    (if (not (new_dialog "SlitDis" dcl_id))     ;   .
        (exit)                                  ; ,     
                                                ;   .
    )

    (action_tile "accept" "(bad_par_SlitDis)")
    
    (action_tile "chk_DO" "(acts_chk_DO)")
    (action_tile "chk_M" "(acts_chk_M)")
    (action_tile "opt_Rot" "(acts_chk_M)")
    (action_tile "opt_Unroll" "(acts_chk_M)")
    
    (im_ImgBoot "img_VD" "ViewDis(SD_)" 0 )
    (set_tile "txt_VD" "A")
    (setq SDis "A")
    (setq f_DO 0)
    (setq f_M 0)

    (action_tile "Ok" "(done_dialog 1)")
    (action_tile "cancel" "(done_dialog 0)")

    ;       "Ok" -  
    (if ( = 1 (start_dialog))
      (progn
            (unload_dialog dcl_id)
            ($ViewDis SDis f_DO f_M M1 M2)
      )
      (unload_dialog dcl_id)
    ) ; if       "Ok" -  
    
)

;;;   
;=============================================================

(defun im_ImgBoot (Tile SlideName f_color / x y)
  (setq	x (dimx_tile Tile)
	y (dimy_tile Tile)
  )
  (start_image Tile)
  (fill_image 0 0 x y f_color)
  (slide_image 0 0 x y SlideName)
  (end_image)
)

;        
(defun bad_par_ViewDis ()
    (progn
        (if (= (get_tile "chk_DO") "1")
            (if (= (get_tile "opt_Rot") "1")
                (setq f_DO 1)
                (setq f_DO 2)
            )
            (setq f_DO 0)
        )
    ) ; progn
    (if (= (get_tile "chk_M") "1")
        (if (not (ai_num (get_tile "txt_M1") "   " 6))
        	(mode_tile "txt_M1" 2)
            (progn
                (setq f_M 1)
                (setq M1 (get_tile "txt_M1"))
                (if (not (ai_num (get_tile "txt_M2") "  : " 6))
                    (mode_tile "txt_M2" 2)
                    (progn
                        (setq M2 (get_tile "txt_M2"))
                        (setq VDis (get_tile "txt_VD"))
                        (if (or (= "" VDis) (null VDis))
                            (progn
                                (set_tile "error" "  ")
                                (mode_tile "txt_VD" 2)
                            )
                            (progn
                                (setq VDis (strcat "%%u" " " VDis))
                                (done_dialog 1)
                            )
                        )
                    )
                )
            )
        )
        (progn
            (setq VDis (get_tile "txt_VD"))
            (if (or (= "" VDis) (null VDis))
                (progn
                    (set_tile "error" "  ")
                    (mode_tile "txt_VD" 2)
                )
                (progn
                    (setq VDis (strcat "%%u" " " VDis))
                    (setq f_M 0)
                    (done_dialog 1)
                )
            )
        )
    )
)

;        
(defun bad_par_SlitDis ()
    (progn
        (if (= (get_tile "chk_DO") "1")
            (if (= (get_tile "opt_Rot") "1")
                (setq f_DO 1)
                (setq f_DO 2)
            )
            (setq f_DO 0)
        )
    ) ; progn
    (if (= (get_tile "chk_M") "1")
        (if (not (ai_num (get_tile "txt_M1") "   " 6))
        	(mode_tile "txt_M1" 2)
            (progn
                (setq f_M 1)
                (setq M1 (get_tile "txt_M1"))
                (if (not (ai_num (get_tile "txt_M2") "  : " 6))
                    (mode_tile "txt_M2" 2)
                    (progn
                        (setq M2 (get_tile "txt_M2"))
                        (setq SDis (get_tile "txt_VD"))
                        (if (or (= "" SDis) (null SDis))
                            (progn
                                (set_tile "error" "  ")
                                (mode_tile "txt_VD" 2)
                            )
                            (progn
                                (setq SDis (strcat "%%u" SDis "-" SDis))
                                (done_dialog 1)
                            )
                        )
                    )
                )
            )
        )
        (progn
            (setq SDis (get_tile "txt_VD"))
            (if (or (= "" SDis) (null SDis))
                (progn
                    (set_tile "error" "  ")
                    (mode_tile "txt_VD" 2)
                )
                (progn
                    (setq SDis (strcat "%%u" SDis "-" SDis))
                    (setq f_M 0)
                    (done_dialog 1)
                )
            )
        )
    )
)

(defun act_chk_DO ( / )
    (if (= (get_tile "chk_DO") "1")
        (progn
            (mode_tile "opt_Rot" 0)
            (mode_tile "opt_Unroll" 0)
            (if (= (get_tile "chk_M") "1")
                (if (= (get_tile "opt_Rot") "1")
                    (im_ImgBoot "img_VD" "ViewDis(VD_RotM)" 0 )
                    (im_ImgBoot "img_VD" "ViewDis(VD_UnrollM)" 0 )
                )
            )
        )
        (progn
            (mode_tile "opt_Rot" 1)
            (mode_tile "opt_Unroll" 1)
            (if (= (get_tile "chk_M") "1")
                (im_ImgBoot "img_VD" "ViewDis(VD_M)" 0 )
                (im_ImgBoot "img_VD" "ViewDis(VD_)" 0 )
            )
        )
    )
    (if (and (/= (get_tile "opt_Rot") "1") (/= (get_tile "opt_Unroll") "1"))
        (set_tile "opt_Rot" "1")
    )
    (act_chk_M)
)

(defun acts_chk_M ( / )
    (if (= (get_tile "chk_M") "1")
        (progn
            (mode_tile "txt_M1" 0)
            (mode_tile "txt_M2" 0)
            (if (= (get_tile "chk_DO") "1")
                (if (= (get_tile "opt_Rot") "1")
                    (im_ImgBoot "img_VD" "ViewDis(SD_RotM)" 0 )
                    (im_ImgBoot "img_VD" "ViewDis(SD_UnrollM)" 0 )
                )
                (im_ImgBoot "img_VD" "ViewDis(SD_M)" 0 )
            )
        )
        (progn
            (mode_tile "txt_M1" 1)
            (mode_tile "txt_M2" 1)
            (if (= (get_tile "chk_DO") "1")
                (if (= (get_tile "opt_Rot") "1")
                    (im_ImgBoot "img_VD" "ViewDis(SD_Rot)" 0 )
                    (im_ImgBoot "img_VD" "ViewDis(SD_Unroll)" 0 )
                )
                (im_ImgBoot "img_VD" "ViewDis(SD_)" 0 )
            )
        )
    )
)

(defun acts_chk_DO ( / )
    (if (= (get_tile "chk_DO") "1")
        (progn
            (mode_tile "opt_Rot" 0)
            (mode_tile "opt_Unroll" 0)
            (if (= (get_tile "chk_M") "1")
                (if (= (get_tile "opt_Rot") "1")
                    (im_ImgBoot "img_VD" "ViewDis(SD_RotM)" 0 )
                    (im_ImgBoot "img_VD" "ViewDis(SD_UnrollM)" 0 )
                )
            )
        )
        (progn
            (mode_tile "opt_Rot" 1)
            (mode_tile "opt_Unroll" 1)
            (if (= (get_tile "chk_M") "1")
                (im_ImgBoot "img_VD" "ViewDis(SD_M)" 0 )
                (im_ImgBoot "img_VD" "ViewDis(SD_)" 0 )
            )
        )
    )
    (if (and (/= (get_tile "opt_Rot") "1") (/= (get_tile "opt_Unroll") "1"))
        (set_tile "opt_Rot" "1")
    )
    (acts_chk_M)
)

(defun act_chk_M ( / )
    (if (= (get_tile "chk_M") "1")
        (progn
            (mode_tile "txt_M1" 0)
            (mode_tile "txt_M2" 0)
            (if (= (get_tile "chk_DO") "1")
                (if (= (get_tile "opt_Rot") "1")
                    (im_ImgBoot "img_VD" "ViewDis(VD_RotM)" 0 )
                    (im_ImgBoot "img_VD" "ViewDis(VD_UnrollM)" 0 )
                )
                (im_ImgBoot "img_VD" "ViewDis(VD_M)" 0 )
            )
        )
        (progn
            (mode_tile "txt_M1" 1)
            (mode_tile "txt_M2" 1)
            (if (= (get_tile "chk_DO") "1")
                (if (= (get_tile "opt_Rot") "1")
                    (im_ImgBoot "img_VD" "ViewDis(VD_Rot)" 0 )
                    (im_ImgBoot "img_VD" "ViewDis(VD_Unroll)" 0 )
                )
                (im_ImgBoot "img_VD" "ViewDis(VD_)" 0 )
            )
        )
    )
)
;;;   
;=============================================================
(princ "\n     Slit.lsp ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.ru               ***")
