;;; This routine will display ISO hole base tolerances.
;;; Also can print these tolerances.
;;; Peter Best  March 1999
;;; ***************************************************
;;;  by SeVa 25.02.2000-02-25
;;;       
;;;        .
;;;        
;;; .
;;;         
;;; .  ,     .
;;;    ,    
;;;        (6, H11  ..).
;;;    (.   ).

;;;--------------------------------------------------------------------;;;
;;;   :     (19.09.00)            ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;
;;; 1.     .        ;;;
;;;          dimtp  dimtm,   ;;;
;;;        .                             ;;;
;;; 2.     ,   , ;;;
;;;     ,             ;;;
;;;         - ;;;
;;;     .                                                    ;;;
;;; 3.   "  ",    ,;;;
;;;       ,   ,    ;;;
;;;      .                                 ;;;
;;;--------------------------------------------------------------------;;;

;error function
(defun-q *error* (msg)
 (setq msg "Function Abort by user")
 (princ)

 (princ msg)
 (princ)
)

;;; This function will save & reset environment ;
(defun set_env ()
  (setq
	oldblip	   (getvar "blipmode")
	;olddimtol  (getvar "dimtol")
	;olddimdec  (getvar "dimdec")
    ;olddimpost (getvar "dimpost")
    ;olddimtp   (getvar "dimtp")
    ;olddimtm   (getvar "dimtm")

	oldecho	   (getvar "cmdecho")
	oldosmode  (getvar "osmode")
	;dscale	   (getvar "dimscale")
	;olddimzin  (getvar "dimzin")
	appname	   "Tols.lsp"
	olderror   *error*
	*error*	   err_hand
	dia	   "0"
	shaft1	   "7"
	shaft2	   "5"
	hole	   "1"
	uht	   "+0.010"
	lht	   "0"
	ust	   "0"
	lst	   "-0.006"
	typefit	   ""
	prefit	   "Locational clearance"
	cmax	   "0.016 "
	cmin	   "  "
	textheight 2
	flags	   0
	flagh	   0
  ) ;_ setq
  (setvar "blipmode" 0)
    ;(setvar "cmdecho" 0)
    ;(setvar "dimzin" 8)
	;(setvar "dimtol" 1)
	;(setvar "dimdec" 3)
	;(setvar "dimtdec" 3)
	;(setvar "dimtolj" 1)
	;(setvar "dimtfac" 0.700)
    ;(setvar "dimpost" " ")

) ;_ defun


;;; This function will load the dialog box.
(defun DialogBox (/ DCL_ID)
  (if (findfile "tols.dcl")		; Looks for dialog box file
    (progn
      	(setq DCL_ID (load_dialog "tols")) ; Load dialog box
      	(setq what_next 2)
      	(setq cnt 1)
	  	(while (>= what_next 2)
       		(if (null (new_dialog "tols" DCL_ID)) ;(null (new_dialog "hidedcl" dcl_id))
	      		(exit)
       		) ;_ end of if
      
      		(setq w (dimx_tile "im")
	    			h (dimy_tile "im")
      		) ;_ end of setq
      		(start_image "im")		; Draws logo
      			(fill_image 0 0 w h 164)
						;
      			(vector_image 1 20 20 2 4)
      			(vector_image 1 2 20 2 4)
      			(vector_image 20 2 20 20 4)
      			(vector_image 20 20 1 20 4)
						;
      			(vector_image 1 20 1 2 4)
      			(vector_image 6 11 6 4 4)
      			(vector_image 6 4 9 4 4)
      			(vector_image 9 4 10 5 4)
      			(vector_image 10 5 10 6 4)
      			(vector_image 10 6 9 7 4)
      			(vector_image 9 7 6 7 4)
						;
      			(vector_image 13 18 13 11 4)
      			(vector_image 13 11 16 11 4)
      			(vector_image 16 11 17 12 4)
      			(vector_image 17 12 17 13 4)
      			(vector_image 17 13 16 14 4)
      			(vector_image 13 14 17 14 4)
      			(vector_image 17 14 18 15 4)
      			(vector_image 18 15 18 17 4)
      			(vector_image 18 17 17 18 4)
      			(vector_image 17 18 13 18 4)
      		(end_image)
      		; Set up buttons
      		(action_tile "info" "(info)(done_dialog 1)(update)")
      		(action_tile "cancel" "(done_dialog 0) (exit)") ;_ end of action_tile
					; Exit out cleanly
      
      
      		(action_tile "shaftnotes"	"(act_shaftnotes)") ; rewriten by Evgeniy Kalashnikov
      		(action_tile "holenotes" "(act_holenotes)") ; rewriten by Evgeniy Kalashnikov
      
      		(action_tile "dia" "(setq dia $value)(update)")
     		(action_tile "getdim" "(done_dialog 4)") ;Added by Evgeniy Kalashnikov
      		(action_tile "chk_TolsType" "(setq TolsType $value)") ;Added by Evgeniy Kalashnikov
      		(action_tile "shaft1" "(setq shaft1 $value)(update)")
      		(action_tile "shaft2" "(setq shaft2 $value)(update)")
      		(action_tile "hole" "(setq hole $value)(update)")
      		(action_tile "cmax" "(setq cmax $value)(update)")
      		(action_tile "cmin" "(setq cmin $value)(update)")
      		(action_tile "typefit" "(setq typefit $value)(update)")
      		(action_tile "prefit" "(setq prefit $value)(update)")
      		
      		(if (not (null i_dianum)) ;Added by Evgeniy Kalashnikov
      			(set_tile "dia" i_dianum) ;Added by Evgeniy Kalashnikov
      		) ;Added by Evgeniy Kalashnikov
      		(setq dia (get_tile "dia"))
      		(set_tile "uht" uht)
      		(set_tile "lht" lht)
      		(set_tile "ust" ust)
      		(set_tile "lst" lst)
      		(set_tile "typefit" typefit)
      		(set_tile "prefit" prefit)
      		(set_tile "cmax" cmax)
      		(set_tile "cmin" cmin)
      		(update)
      		(set_tile "chk_TolsType" "1") ;Added by Evgeniy Kalashnikov
      		(setq TolsType (get_tile "chk_TolsType")) ;Added by Evgeniy Kalashnikov
      		(setq what_next (start_dialog))
            ; Added by Evgeniy Kalashnikov
            (cond
      		  ((= what_next 4)                       ;Prompt user to
        		(progn
		    		(setq flg 1)
    				(setq dim_Val nil)
    				(while (= flg 1)
       					(progn
        					(setq Obj1 (entsel "\n :"))
							(if (not (null Obj1))
								(progn
									(setq e_name (car Obj1))
    								(setq e_list (entget e_name))
    								(if (/= (cdr (assoc 0 e_list)) "DIMENSION")
    									(progn
    										(princ "\n  ")
    										(setq flg 1)
    										(setq dim_Val nil)
    										(setq e_name nil)
    									)
    									(progn
    										(setq dim_Val (cdr (assoc 42 e_list)))
    										(setq flg 0)
    									)
    								)
      							)
    						)
    					)
    				)
    				(if (not (null dim_Val))
						(get_dimDia)
    				)
        		); end of progn
     		  ); end of (= what_next 4)
      		  ((= what_next 0)
        		(prompt "\nuser cancelled dialog")
      		  ); end of (= what_next 0)
		    ); end of cond
      	);end of while
	    (unload_dialog dcl_id)
	    (setq i_dianum nil) ;Added by Evgeniy Kalashnikov
	    ;(setq dim_Val nil)
    ) ;_ end of progn
    ;(alert "Unable to find Tols.dcl")
  ) ;_ end of if
) ;_ end of defun

;;;***
;; Added by Evgeniy Kalashnikov
;;      
;;    
(defun get_dimDia ()
	(setq i_dianum nil)
	(if (not (null dim_Val))
		(cond
			((<= dim_Val 3) (setq i_dianum "0"))
			((and (> dim_Val 3) (<= dim_Val 6)) (setq i_dianum "1"))
			((and (> dim_Val 6) (<= dim_Val 10)) (setq i_dianum "2"))
			((and (> dim_Val 10) (<= dim_Val 14)) (setq i_dianum "3"))
			((and (> dim_Val 14) (<= dim_Val 18)) (setq i_dianum "4"))
			((and (> dim_Val 18) (<= dim_Val 24)) (setq i_dianum "5"))
			((and (> dim_Val 24) (<= dim_Val 30)) (setq i_dianum "6"))
			((and (> dim_Val 30) (<= dim_Val 40)) (setq i_dianum "7"))
			((and (> dim_Val 40) (<= dim_Val 50)) (setq i_dianum "8"))
			((and (> dim_Val 50) (<= dim_Val 65)) (setq i_dianum "9"))
			((and (> dim_Val 65) (<= dim_Val 80)) (setq i_dianum "10"))
			((and (> dim_Val 80) (<= dim_Val 100)) (setq i_dianum "11"))
			((and (> dim_Val 100) (<= dim_Val 120)) (setq i_dianum "12"))
			((and (> dim_Val 120) (<= dim_Val 140)) (setq i_dianum "13"))
			((and (> dim_Val 140) (<= dim_Val 160)) (setq i_dianum "14"))
			((and (> dim_Val 160) (<= dim_Val 180)) (setq i_dianum "15"))
			((and (> dim_Val 180) (<= dim_Val 200)) (setq i_dianum "16"))
			((and (> dim_Val 200) (<= dim_Val 225)) (setq i_dianum "17"))
			((and (> dim_Val 225) (<= dim_Val 250)) (setq i_dianum "18"))
			((and (> dim_Val 250) (<= dim_Val 280)) (setq i_dianum "19"))
			((and (> dim_Val 280) (<= dim_Val 315)) (setq i_dianum "20"))
			((and (> dim_Val 315) (<= dim_Val 335)) (setq i_dianum "21"))
			((and (> dim_Val 335) (<= dim_Val 400)) (setq i_dianum "22"))
			((and (> dim_Val 400) (<= dim_Val 450)) (setq i_dianum "23"))
			((> i_dianum 450) (setq i_dianum 24))
		)
	)
	;t i_dianum
)

;;;***
;Added by Evgeniy Kalashnikov
;; ,     ".." ( )
(defun act_getdim ()
	(done_dialog 1)
	(setq what_next 2)
	;(setq e_dim get_Dim)
)

;;;***
;Added by Evgeniy Kalashnikov
;; ,    
;;    .
(defun get_Dim ()
    (setq flg 1)
    (setq dim_Val nil)
    (while (= flg 1)
       (progn
        (setq Obj1 (entsel "\n :"))
		(setq e_name (car Obj1))
    	(setq e_list (entget e_name))
    	(if (/= (cdr (assoc 0 e_list)) "DIMENSION")
    		(progn
    			(princ "\n  ")
    			(setq flg 1)
    			(setq dim_Val nil)
    			(setq e_name nil)
    		)
    		(progn
    			(setq dim_Val (cdr (assoc 42 e_list)))
    			(setq flg 0)
    		)
    	)
      )
    )
    t e_name
)

;;;***
;; Added by Evgeniy Kalashnikov
;; ,     " "
(defun act_holenotes ()
	(setq flagh 1)
	(update)
	(setq str_hole (get_holenotes))
	(done_dialog 1)
)

;;       
;;    
(defun get_holenotes ( / sym_hole count lst_hole)
	(setq count (atoi (get_tile "hole")))
    (setq lst_hole (list "H6" "H7" "H8" "H9" "H10" "H11"))
    (setq sym_hole (nth count lst_hole))
    t sym_hole
)

;;;***
;Added by Evgeniy Kalashnikov
;; ,     " "
(defun act_shaftnotes ()
	(setq flags 1)
	(update)
	(setq str_shaft (get_shaftnotes))
	(done_dialog 1)
)

;;       
;;    
(defun get_shaftnotes ( / sym_shaft num_shaft ret_shaft count lst_shaft)
	(setq count (atoi (get_tile "shaft1")))
	(setq lst_shaft (list "a" "b" "c" "d" "e" "f" "g" "h" "js" "j" "k" "m" "n" "p" "r" "s" "t" "u" "v" "x" "y" "z"))
    (setq sym_shaft (nth count lst_shaft))
    (setq num_shaft (itoa (+ 1 (atoi (get_tile "shaft2")))))
    (setq ret_shaft (strcat sym_shaft num_shaft))	
    t ret_shaft
)
(defun update ()
  (setq	flsize '("0to3"		     "over3to6"
		 "over6to10"	     "over10to14"
		 "over14to18"	     "over18to24"
		 "over24to30"	     "over30to40"
		 "over40to50"	     "over50to65"
		 "over65to80"	     "over80to100"
		 "over100to120"	     "over120to140"
		 "over140to160"	     "over160to180"
		 "over180to200"	     "over200to225"
		 "over225to250"	     "over250to280"
		 "over280to315"	     "over315to355"
		 "over355to400"	     "over400to450"
		 "over450to500"
		)
  ) ;_ end of setq
  (setq diax (nth (atoi dia) flsize))	;setting diax to diameter range
  (grab)				; will retrieve all std deviations for diameter range
  (setq	stddev	(/ (nth (atoi shaft1) dlist) 1000)
					;getting std dev. for shaft
	stddev1	stddev
  ) ;_ end of setq
  (if (and (= shaft1 "9") (> shaft2 "3") (< shaft2 "6"))
					; j5 & j6 std dev. for shaft
    (setq stdj56 (/ (nth 22 dlist) 1000))
  ) ;_ end of if
  (if (and (= shaft1 "9") (= shaft2 "6")) ; j7 std dev. for shaft
    (setq stdj7 (/ (nth 23 dlist) 1000))
  ) ;_ end of if
  (if (and (= shaft1 "10") (> shaft2 "2") (< shaft2 "7"))
					; k4-7 std dev. for shaft
    (setq stdk4_7 (/ (nth 24 dlist) 1000))
  ) ;_ end of if

  (if (< stddev 0)
    (setq flag 1)
  ) ;_ end of if
  (if (= stddev 0)
    (setq flag 2)
  ) ;_ end of if
  (if (> stddev 0)
    (setq flag 3)
  ) ;_ end of if
  (setq stddev (rtos stddev 2 4))
  (if (= flag 1)
    (while (< (strlen stddev) 6)
      (setq stddev (strcat stddev "0"))
    ) ;_ end of while
  ) ;_ end of if
  (if (= flag 3)
    (progn
      (setq stddev (strcat "+" stddev))
      (while (< (strlen stddev) 6)
	(setq stddev (strcat stddev "0"))
      ) ;_ end of while
    ) ;_ end of progn
  ) ;_ end of if


  (setq	flsize '("*0to3"	      "*over3to6"
		 "*over6to10"	      "*over10to14"
		 "*over14to18"	      "*over18to24"
		 "*over24to30"	      "*over30to40"
		 "*over40to50"	      "*over50to65"
		 "*over65to80"	      "*over80to100"
		 "*over100to120"      "*over120to140"
		 "*over140to160"      "*over160to180"
		 "*over180to200"      "*over200to225"
		 "*over225to250"      "*over250to280"
		 "*over280to315"      "*over315to355"
		 "*over355to400"      "*over400to450"
		 "*over450to500"
		)
  ) ;_ end of setq
  (setq diax (nth (atoi dia) flsize))	;setting diax to diameter range
  (grab)				; will retrieve all grades for diameter range
  (setq grade (/ (nth (atoi shaft2) dlist) 1000))
  (if (= shaft1 "8")			; js shaft grade
    (setq gradejs (/ grade 2))
  ) ;_ end of if
  (if (<= (atoi shaft1) 7)
    (setq lst (- stddev1 grade))
    (setq lst (+ stddev1 grade))
  ) ;_ end of if
  (if (< lst 0)
    (setq flag 1)
  ) ;_ end of if
  (if (= lst 0)
    (setq flag 2)
  ) ;_ end of if
  (if (> lst 0)
    (setq flag 3)
  ) ;_ end of if
  (setq lst (rtos lst 2 4))
  (if (= flag 1)			; add zeros if required
    (while (< (strlen lst) 6)
      (setq lst (strcat lst "0"))
    ) ;_ end of while
  ) ;_ end of if
  (if (= flag 3)			; add "+" & zeros if required
    (progn
      (setq lst (strcat "+" lst))
      (while (< (strlen lst) 6)
	(setq lst (strcat lst "0"))
      ) ;_ end of while
    ) ;_ end of progn
  ) ;_ end of if

  (setq	uht (/ (nth (+ (atoi hole) 5) dlist) 1000) ; reads upper hole
	uht (rtos uht 2 4)		; tols from list
	uht (strcat "+" uht)
  ) ;_ end of setq
  (while (< (strlen uht) 6)
    (setq uht (strcat uht "0"))
  ) ;_ end of while

  (setq ust stddev)

  (if (> (atof lst) 0)			;if lower shaft tols is positive
    (progn				;then swap ust and lst around
      (setq temp1 lst			;for dialog box.
	    lst	ust
	    ust	temp1
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (= shaft1 "8")			; js
    (progn
      (setq ust (strcat "+" (rtos gradejs 2 3)))
      (while (< (strlen ust) 6)
	(setq ust (strcat ust "0"))
      ) ;_ end of while
      (setq lst (strcat "-" (rtos gradejs 2 3)))
      (while (< (strlen lst) 6)
	(setq lst (strcat lst "0"))
      ) ;_ end of while
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "9") (> shaft2 "3") (< shaft2 "6"))
					; j5 & j6 shaft tols
    (progn
      (setq ust	(strcat "+" (rtos (+ stdj56 grade) 2 3))
	    lst	(rtos stdj56 2 3)
      ) ;_ end of setq
      (while (< (strlen ust) 6)
	(setq ust (strcat ust "0"))
      ) ;_ end of while
      (while (< (strlen lst) 6)
	(setq lst (strcat lst "0"))
      ) ;_ end of while
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "9") (= shaft2 "6")) ; j7 shaft tols
    (progn
      (setq ust	(strcat "+" (rtos (+ stdj7 grade) 2 4))
	    lst	(rtos stdj7 2 4)
      ) ;_ end of setq
      (while (< (strlen ust) 6)
	(setq ust (strcat ust "0"))
      ) ;_ end of while
      (while (< (strlen lst) 6)
	(setq lst (strcat lst "0"))
      ) ;_ end of while
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "10") (<= shaft2 "2") (> shaft2 "6"))
					; k1_3 & k8+ std dev. for shaft
    (setq lst "0")
  ) ;_ end of if
  (if (and (= shaft1 "10") (> shaft2 "2") (< shaft2 "7"))
					; k4-7 std dev. for shaft
    (progn
      (setq ust	(strcat "+" (rtos (+ stdk4_7 grade) 2 4))
	    lst	(rtos stdk4_7 2 4)
      ) ;_ end of setq
      (while (< (strlen ust) 6)
	(setq ust (strcat ust "0"))
      ) ;_ end of while
      (if (/= lst "0")
	(progn
	  (setq lst (strcat "+" lst))
	  (while (< (strlen lst) 6)
	    (setq lst (strcat lst "0"))
	  ) ;_ end of while
	) ;_ end of progn
      ) ;_ end of if
    ) ;_ end of progn
  ) ;_ end of if

  (if (and (= shaft1 "9") (>= shaft2 "0") (< shaft2 "4"))
					; j4 downwards
    (progn
      (setq ust	"N/A"
	    lst	"N/A"
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "9") (>= shaft2 "7")) ; j8 upwards
    (progn
      (setq ust	"N/A"
	    lst	"N/A"
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if


  (if (and (= shaft1 "16") (<= (atoi dia) 5)) ; t
    (progn
      (setq ust	"Use \"u\""
	    lst	"Use \"u\""
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "18") (<= (atoi dia) 3)) ; v
    (progn
      (setq ust	"Use \"x\""
	    lst	"Use \"x\""
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "20") (<= (atoi dia) 4)) ; y
    (progn
      (setq ust	"Use \"z\""
	    lst	"Use \"z\""
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if

  (set_tile "ust" ust)			; Shows Upper shaft tol. in dialog box
  (set_tile "lst" lst)			; Shows Lower shaft tol. in dialog box
  (set_tile "uht" uht)			; Shows Upper hole tol. in dialog box


;;;Works out maximum condition
;;;Largest hole/smallest shaft
  (setq	flagmax	0
	cmax	(rtos (- (atof uht) (atof lst)) 2 4)
  ) ;_ end of setq
  (while (< (strlen cmax) 5)
    (setq cmax (strcat cmax "0"))
  ) ;_ end of while

  (if (= (atof cmax) 0)
    (setq cmax "  ")
  ) ;_ end of if
  (if (> (atof cmax) 0)
    (progn
      (setq flagmax 1
	    cmax    (strcat cmax " ")
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if

  (if (< (atof cmax) 0)
    (progn
      (setq flagmax 2
	    cmax    (rtos (* (atof cmax) -1) 2 4)
      ) ;_ end of setq
					; gets rid of minus sign
      (while (< (strlen cmax) 5)
	(setq cmax (strcat cmax "0"))
      ) ;_ end of while
      (setq cmax (strcat cmax " "))
    ) ;_ end of progn
  ) ;_ end of if

;;;Works out minimum condition
;;;Smallest hole (always zero)/largest shaft
  (setq	cmin	(rtos (- 0.0 (atof ust)) 2 4)
	flagmin	0
  ) ;_ end of setq

  (if (= (atof cmin) 0)
    (setq cmin "  ")
  ) ;_ end of if
  (if (> (atof cmin) 0)
    (progn
      (setq flagmin 1)
      (while (< (strlen cmin) 5)
	(setq cmin (strcat cmin "0"))
      ) ;_ end of while
      (setq cmin (strcat cmin " "))
    ) ;_ end of progn
  ) ;_ end of if

  (if (< (atof cmin) 0)
    (progn
      (setq flagmin 2
	    cmin    (rtos (* (atof cmin) -1) 2 4)
      ) ;_ end of setq
					; gets rid of minus sign
      (while (< (strlen cmin) 5)
	(setq cmin (strcat cmin "0"))
      ) ;_ end of while
      (setq cmin (strcat cmin " "))
    ) ;_ end of progn
  ) ;_ end of if


  (if (and (= flagmax flagmin) (< (atof cmax) (atof cmin)))
    (progn
      (setq temp1 cmax
	    cmax  cmin
	    cmin  temp1
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "9") (>= shaft2 "0") (< shaft2 "4"))
					; j4 downwards
    (progn
      (setq cmax " "
	    cmin " "
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "9") (>= shaft2 "7")) ; j8 upwards
    (progn
      (setq cmax " "
	    cmin " "
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "16") (<= (atoi dia) 5))
    (progn
      (setq cmax " "
	    cmin " "
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "18") (<= (atoi dia) 3))
    (progn
      (setq cmax " "
	    cmin " "
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if
  (if (and (= shaft1 "20") (<= (atoi dia) 4))
    (progn
      (setq cmax " "
	    cmin " "
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if

  (set_tile "cmax" cmax)		; Shows max condition in dialog box
  (set_tile "cmin" cmin)		; Shows min condition in dialog box

;;; Checking for type of fit

  (if (<= (atof shaft1) 7)
    (setq typefit " ")
  ) ;_ end of if
  (if (and (> (atof shaft1) 7) (< (atof shaft1) 13))
    (setq typefit "")
  ) ;_ end of if
  (if (> (atof shaft1) 12)
    (setq typefit " ")
  ) ;_ end of if

;;; Transition if cmax and cmin are different and no size for size
  (setq flagx 0)
  (if (or (= cmax "   ") (= cmin "   "))
    (setq flagx 1)
  ) ;_ end of if
  (if (and (/= flagmax flagmin) (= flagx 0))
    (setq typefit "")
  ) ;_ end of if

  (if (and (= shaft1 "16") (<= (atoi dia) 5))
    (setq typefit " ")
  ) ;_ end of if
  (if (and (= shaft1 "18") (<= (atoi dia) 3))
    (setq typefit " ")
  ) ;_ end of if
  (if (and (= shaft1 "20") (<= (atoi dia) 4))
    (setq typefit " ")
  ) ;_ end of if
  (if (and (= shaft1 "9") (>= shaft2 "0") (< shaft2 "4"))
					; j4 downwards
    (setq typefit " ")
  ) ;_ end of if
  (if (and (= shaft1 "9") (>= shaft2 "7")) ; j8 upwards
    (setq typefit " ")
  ) ;_ end of if

  (set_tile "typefit" typefit)		; Shows type of fit in dialog box

;;; Checking for a "Prefered Fit"

  (setq prefit "                  ")	; clears "Preferred fit" window
  (if (and (= hole "5") (= shaft1 "2") (= shaft2 "10"))
    (setq prefit "Loose running")
  ) ;_ end of if
  (if (and (= hole "3") (= shaft1 "3") (= shaft2 "8"))
    (setq prefit "Free running")
  ) ;_ end of if
  (if (and (= hole "2") (= shaft1 "5") (= shaft2 "6"))
    (setq prefit "Close running")
  ) ;_ end of if
  (if (and (= hole "1") (= shaft1 "6") (= shaft2 "5"))
    (setq prefit "Sliding fit")
  ) ;_ end of if
  (if (and (= hole "1") (= shaft1 "7") (= shaft2 "5"))
    (setq prefit "Locational clearance")
  ) ;_ end of if
  (if (and (= hole "1") (= shaft1 "10") (= shaft2 "5"))
    (setq prefit "Location transition")
  ) ;_ end of if
  (if (and (= hole "1") (= shaft1 "12") (= shaft2 "5"))
    (setq prefit "Location transition")
  ) ;_ end of if
  (if (and (= hole "1") (= shaft1 "13") (= shaft2 "5"))
    (setq prefit "Location interference")
  ) ;_ end of if
  (if (and (= dia "0") (= shaft1 "13"))
    (setq prefit "                  ")
  ) ;_ end of if
  (if (and (= hole "1") (= shaft1 "15") (= shaft2 "5"))
    (setq prefit "Medium drive")
  ) ;_ end of if
  (if (and (= hole "1") (= shaft1 "17") (= shaft2 "5"))
    (setq prefit "Force")
  ) ;_ end of if

  (set_tile "prefit" prefit)

  (setq	flsize '("a"   "b"   "c"   "d"	 "e"   "f"   "g"   "h"	 "js"
		 "j"   "k"   "m"   "n"	 "p"   "r"   "s"   "t"	 "u"
		 "v"   "x"   "y"   "z"
		)
  ) ;_ end of setq
  (setq let (nth (atoi shaft1) flsize))	;setting let to letter value
  (setq	flsize '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "11" "12" "13"
		 "14" "15" "16")
  ) ;_ end of setq
  (setq num (nth (atoi shaft2) flsize))	;setting num to number value
  (setq	flsize '("H6"
		 "H7"
		 "H8"
		 "H9"
		 "H10"
		 "H11"
		)
  ) ;_ end of setq
  (setq holesize (nth (atoi hole) flsize))
					;setting holesize to "H" value

) ;_ end of defun

;;;***
; Rewriten by Evgeniy Kalashnikov
;;; This function will write
;;; out the shaft tolerance
(defun shaftnotes ()
	(setvar "cmdecho" 1)
	(setvar "osmode" 0)

	;(setvar "dimtp" (atof ust))
	(setq n_dimtp ust) ;  
	(if (= n_dimtp "0") ;     "0"
		(setq n_dimtp "+0") ;     "+0"
	)
	
	;(setvar "dimtm" (* (atof lst) -1.0))
	;(setq n_dimtm (rtos (* (atof lst) -1.0) 2 3))
	(setq n_dimtm lst) ;  
	(if (= n_dimtm "0") ;     "0"
		(setq n_dimtm "-0") ;     "-0"
	)
	
	(if (= TolsType "1") ;       
		(setq dimTxt (strcat "<> " str_shaft " (" "\\H0.5x" "\\S" n_dimtp "^" n_dimtm ";\\H2.0x)"))
		(setq dimTxt (strcat "<>" "\\H0.5x" "\\S" n_dimtp "^" n_dimtm))
	)
	
	(if (null e_name) ;    
		(setq e_name (get_Dim)) ;      
	)
    (if (not (null e_name)) ;    
    	(progn ;    
    		(setq e_list (entget e_name))
			(setq e_list (subst (cons 1 dimTxt) (assoc 1 e_list) e_list ))
			(entmod e_list)
		)
	)
	(setq e_name nil)
	;(command "dimstyle" "A" pause "")
	;(command "ddedit" "P" "");; ,    
	(setvar "osmode" oldosmode)
) ;_ end of defun

;;;***
; Rewriten by Evgeniy Kalashnikov
;;; This function will write
;;; out the hole tolerance
(defun holenotes ()
	(setvar "cmdecho" 1)
    (setvar "osmode" 0)

	;(setvar "dimtp" (atof uht))
	(setq n_dimtp uht) ;  
	(if (= n_dimtp "0") ;     "0"
		(setq n_dimtp "+0") ;     "+0"
	)
	;(setvar "dimtm" (* (atof lht) -1.0))
	;(setq n_dimtm (rtos (* (atof lht) -1.0)))
	(setq n_dimtm lht) ;  
	(if (= n_dimtm "0") ;     "0"
		(setq n_dimtm "-0") ;     "-0"
	)

	(if (= TolsType "1") ;       
		(setq dimTxt (strcat "<> " str_hole " (" "\\H0.5x" "\\S" n_dimtp "^" n_dimtm ";\\H2.0x)"))
		(setq dimTxt (strcat "<>" "\\H0.5x" "\\S" n_dimtp "^" n_dimtm))
	)

	(if (null e_name) ;    
		(setq e_name (get_Dim)) ;      
	)
    
    (if (not (null e_name)) ;    
    	(progn ;    
    		(setq e_list (entget e_name))
			(setq e_list (subst (cons 1 dimTxt) (assoc 1 e_list) e_list ))
			(entmod e_list)
		)
	)
	(setq e_name nil)
	;(command "dimstyle" "A" pause "")
	;(command "ddedit" "P" "" (command));; ,    
	(setvar "osmode" oldosmode)
) ;_ end of defun


;;; This function will read a list
;;; and create the variable "dlist"
(defun grab ()
  (setq	dlist nil
	diax  (strcat "*" diax)
	file  (findfile "tols.lst")
	fp    (open file "r")
	item  (read-line fp)
  )					;setq
  (while item
    (if	(= item diax)
      (setq data (read-line fp)
	    item nil
      )					;setq
      (setq item (read-line fp))
    )					;if
  )					;while
  (if data
    (progn
      (setq maxs  (strlen data)
	    count 1
	    chrct 1
      )					;setq
      (while (< count maxs)
	(if (/= "," (substr data count 1))
	  (setq chrct (1+ chrct))
	  (setq	numb  (atof (substr data (1+ (- count chrct)) chrct))
		dlist (append dlist (list numb))

		chrct 1
	  )				;setq
	)				;if
	(setq count (1+ count))
      )					;while
      (setq numb  (atof (substr data (1+ (- count chrct))))
	    dlist (append dlist (list numb))
      )					;setq
    )					;progn
  )					;if data
  (close fp)
)					;defun


;;; This function will display the info box.
(defun info ()
  (if (not (new_dialog "info" DCL_ID))
    (exit)
  ) ;_ end of if
  (action_tile "accept" "(done_dialog 1)")
  (start_dialog)
  ;(DialogBox)
) ;_ end of defun


;;; MARK marks the database for use with CATCH.
;;; Written by Kenny Ramage Feb. '95
(defun MARK (/ val)
  (setq val (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (if (setq #mark (entlast))
    nil
    (progn
      (entmake '((0 . "POINT") (10 0.0 0.0 0.0)))
      (setq #mark (entlast))
      (entdel #mark)
    ) ;_ end of progn
  ) ;_ end of if
  (setvar "cmdecho" val)
  (princ)
) ;_ end of defun

;;;CATCH starts at MARK and retrieves to the end of the database.
(defun CATCH (/ ss)
  (if #mark
    (progn
      (setq ss (ssadd))
      (while (setq #mark (entnext #mark))
	(ssadd #mark ss)
      )					;while
      ss
    )					;progn then
    (prompt "\n#MARK not set. Run MARK before CATCH.\n") ;else
  )					;if
)					;defun
(princ)
					;* end of CATCH.LSP


;;; This function will reset the original enviroment.
(defun res_env ()
  (setvar "blipmode" oldblip)
  (setvar "cmdecho" oldecho)
  (setvar "osmode" oldosmode)
  (setvar "clayer" oldlayer)
  ;(setvar "dimzin" olddimzin)
  ;(setvar "dimtol" olddimtol)
  ;(setvar "dimdec" olddimdec)
  ;(setvar "dimpost" olddimpost)
  ;(setvar "dimtp" olddimtp)
  ;(setvar "dimtm" olddimtm)

  (setq *error* olderror)
  (princ)
  (princ)
) ;_ end of defun

;;; This function will reset the original enviroment,
;;; display an exit message and exit cleanly.
(defun err_hand	(msg)
  (setvar "blipmode" oldblip)
  (setvar "cmdecho" oldecho)
  (setvar "osmode" oldosmode)
  ;(setvar "dimzin" olddimzin)

	           ;(setvar "dimtol" olddimtol)
	           ;(setvar "dimdec" olddimdec)
             ;(setvar "dimpost" olddimpost)
             ;(setvar "dimtp" olddimtp)
             ;(setvar "dimtm" olddimtm)

  (setq *error* olderror)
  (princ
    (strcat "\n*** Exit out of " appname " ***\n")
  ) ;_ end of prompt
  (princ)
) ;_ end of defun

;;; Main program
(defun C:Tols ()
	;;   ,    ;;
	;;    ,    ;;
	;;                ;;
	;(command "_select" "_R" "")
	;(if (not (null (setq e_name (get_Dim))))
	;	(progn
	;		;(princ "  ")
	;		(setq e_list (entget e_name))
	;		(setq dim_Val (cdr (assoc 42 e_list)))
	;		(get_dimDia)
	;	)
	;	(progn
	;		(setq i_dianum nil)
  	;		(setq dim_Val nil)
  	;		(setq e_name nil)
  	;		(princ)
  	;	)
	;)
  (set_env)				; sets the enviroment
  (DialogBox)				; loads dialog box
  (if (= flags 1)
    (shaftnotes)
    (setq flags 0)
  ) ;_ end of if
  (if (= flagh 1)
    (holenotes)
    (setq flagh 0)
  ) ;_ end of if
  (res_env)				; resets the original enviroment
  (setq i_dianum nil)
  (setq dim_Val nil)
  (setq e_name nil)
  (princ)
) ;_ end of defun


(princ
  "\nTolerance program by Peter Best & SeVa is loaded: "
) ;_ end of princ
(princ)
